(** Transformations on XHTML <form> elements *)

(* Is an expression a <form l:action ... > expression? *)
val islform : _ Expression.Expr.expression' -> bool

(* Is an expression a <a l:href ... > expression? *)
val islhref : _ Expression.Expr.expression' -> bool

(* Add an l:action attribute into an XML form expression *)
val add_attrs : (string * 'data Expression.Expr.expression') list -> 'data Expression.Expr.expression' -> 'data Expression.Expr.expression' 

(** Serialise the continuation and environment; adjust the form accordingly *)
val xml_transform : Result.environment 
                 -> (string -> Result.result)
                 -> (Syntax.expression -> Result.continuation -> Result.result)
                 -> Syntax.expression
                 -> Syntax.expression

val is_special : string -> bool
