(** Type inference via the Damas-Milner algorithm, with support for rows *)
open Expression

module  Unify : (sig
  exception Unify_failure of string
  val unify : string list -> Typeenv.omega -> Syntax.expression option -> bool -> Types.datatype * Types.datatype -> Subst.subst
  val unify_old : Typeenv.omega -> Types.datatype * Types.datatype -> unit    
end)

val type_program  : Typeenv.omega -> Syntax.untyped_program ->
  Typeenv.omega * Syntax.program

val type_expression : Typeenv.omega -> Syntax.untyped_expression ->
  Typeenv.omega * Syntax.expression
    
