DROP TABLE test_label;
DROP TYPE label CASCADE;

CREATE FUNCTION label_in(cstring) 
  RETURNS label 
  AS '/Users/b/links/selinks/branches/fable/pgsql/label' 
  LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION label_out(label) 
  RETURNS cstring 
  AS '/Users/b/links/selinks/branches/fable/pgsql/label' 
  LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION label_abs_eq(label, label)
  RETURNS bool
  AS '/Users/b/links/selinks/branches/fable/pgsql/label' 
  LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION label_abs_neq(label, label)
  RETURNS bool
  AS '/Users/b/links/selinks/branches/fable/pgsql/label' 
  LANGUAGE C IMMUTABLE STRICT;

CREATE TYPE label (
  internallength = variable, 
  input = label_in, 
  output = label_out,
  alignment = int4
);

CREATE OPERATOR = (
   leftarg = label, rightarg = label, procedure = label_abs_eq,
   commutator = = ,
   negator = <> ,
   restrict = eqsel, join = eqjoinsel
);

CREATE OPERATOR <> (
   leftarg = label, rightarg = label, procedure = label_abs_neq,
   commutator = <> ,
   negator = = ,
   restrict = neqsel, join = neqjoinsel
);

CREATE FUNCTION label_get_arg(label, int4) RETURNS label
  AS '/Users/b/links/selinks/branches/fable/pgsql/label' 
  LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION label_num_args(label) RETURNS int4
  AS '/Users/b/links/selinks/branches/fable/pgsql/label'
  LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION label_get_name(label) RETURNS text
  AS '/Users/b/links/selinks/branches/fable/pgsql/label'
  LANGUAGE C IMMUTABLE STRICT;

CREATE OPERATOR CLASS label_abs_ops
  DEFAULT FOR TYPE label USING btree AS
    OPERATOR        1       = ,
    OPERATOR        2       <> ;
--  FUNCTION        1       label_get_arg(label, int4);

CREATE TABLE test_label (a label, b label);

INSERT INTO test_label VALUES ('Foo', 'Bar(Ball)');
INSERT INTO test_label VALUES ('High', 'High(Lo)');
INSERT INTO test_label VALUES ('High', 'High(A)');       
INSERT INTO test_label VALUES ('Bar', 'Cons(Foo,Empty)');

-- CREATE INDEX test_label_ind ON test_label
--    USING btree(a label_abs_ops);

SELECT * from test_label WHERE a = 'Foo';

SELECT * FROM test_label WHERE a <> b;

SELECT label_get_arg(b,0) FROM test_label;

SELECT * from test_label WHERE b = 'High(_)';

SELECT label_get_arg(b,1) FROM test_label WHERE a = 'Bar';
SELECT label_get_arg('Foo(Alpha,Bar)', 1);

--DROP TABLE test_label;
--DROP TYPE label CASCADE;

