--
-- PostgreSQL database dump
--

SET client_encoding = 'SQL_ASCII';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: selinks
--

COMMENT ON SCHEMA public IS 'Standard public schema';


--
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: selinks
--

CREATE PROCEDURAL LANGUAGE plpgsql;


SET search_path = public, pg_catalog;

--
-- Name: label; Type: SHELL TYPE; Schema: public; Owner: selinks
--

CREATE TYPE label;


--
-- Name: label_in(cstring); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_in(cstring) RETURNS label
    AS '/Users/b/links/selinks/branches/fable/pgsql/label', 'label_in'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.label_in(cstring) OWNER TO postgres;

--
-- Name: label_out(label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_out(label) RETURNS cstring
    AS '/Users/b/links/selinks/branches/fable/pgsql/label', 'label_out'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.label_out(label) OWNER TO postgres;

--
-- Name: label; Type: TYPE; Schema: public; Owner: selinks
--

CREATE TYPE label (
    INTERNALLENGTH = variable,
    INPUT = label_in,
    OUTPUT = label_out,
    ALIGNMENT = int4,
    STORAGE = plain
);


ALTER TYPE public.label OWNER TO postgres;

--
-- Name: _user; Type: TYPE; Schema: public; Owner: selinks
--

CREATE TYPE _user AS (
	id integer,
	name text
);


ALTER TYPE public._user OWNER TO postgres;

--
-- Name: a_function(); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION a_function() RETURNS integer
    AS $$
DECLARE
  an_integer int4;
BEGIN
  an_integer := 10 * 10;
  return an_integer;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.a_function() OWNER TO postgres;

--
-- Name: bar(label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION bar(label) RETURNS text
    AS $_$
DECLARE
  x_g905 ALIAS FOR $1;
  _g852_g903 _label;
  _g854_g901 label;
  _g853_g902 _label;
  _g856_g899 _label;
  _g858_g897 label;
  _g857_g898 _label;
  _g860_g895 _label;
BEGIN
  IF label_get_name(x_g905) = 'Cons' THEN
    _g852_g903 := label_get_args(x_g905);
    _g854_g901 := hd(_g852_g903);
    _g853_g902 := tl(_g852_g903);
    IF label_get_name(_g854_g901) = 'Foo' THEN
      _g856_g899 := label_get_args(_g854_g901);
      _g858_g897 := hd(_g853_g902);
      _g857_g898 := tl(_g853_g902);
      IF label_get_name(_g858_g897) = 'Nil' THEN
        _g860_g895 := label_get_args(_g858_g897);
        RETURN 'candy';
      ELSE
        RETURN 'buzz';
      END IF;
    ELSE
      RETURN 'buzz';
    END IF;
  ELSE
    RETURN 'buzz';
  END IF;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.bar(label) OWNER TO postgres;

--
-- Name: check_pw(integer, text); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION check_pw(integer, text) RETURNS boolean
    AS $_$
DECLARE
  -- Declare aliases for user input
  uid ALIAS FOR $1;
  pword ALIAS FOR $2;
  nmatches integer NOT NULL := 0;
BEGIN
  SELECT INTO nmatches COUNT(*) FROM users WHERE userid = uid AND password = pword; 
  return nmatches > 0;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.check_pw(integer, text) OWNER TO postgres;

--
-- Name: complex_in(cstring); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION complex_in(cstring) RETURNS complex
    AS '/Users/b/links/selinks/install/dbs/postgresql-8.2.1/src/tutorial/complex', 'complex_in'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.complex_in(cstring) OWNER TO postgres;

--
-- Name: foo(label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION foo(label) RETURNS text
    AS $_$
DECLARE
  x_g922 ALIAS FOR $1;
  _g865_g920 _label;
  _g867_g918 label;
  _g866_g919 _label;
  _g869_g916 _label;
  _g871_g914 label;
  _g870_g915 _label;
  _g873_g912 _label;
BEGIN
  IF label_get_name(x_g922) = 'Cons' THEN
    _g865_g920 := label_get_args(x_g922);
    _g867_g918 := hd(_g865_g920);
    _g866_g919 := tl(_g865_g920);
    IF label_get_name(_g867_g918) = 'Foo' THEN
      _g869_g916 := label_get_args(_g867_g918);
      _g871_g914 := hd(_g866_g919);
      _g870_g915 := tl(_g866_g919);
      IF label_get_name(_g871_g914) = 'Nil' THEN
        _g873_g912 := label_get_args(_g871_g914);
        RETURN 'candy';
      ELSE
        RETURN 'buzz';
      END IF;
    ELSE
      RETURN 'buzz';
    END IF;
  ELSE
    RETURN 'buzz';
  END IF;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.foo(label) OWNER TO postgres;

--
-- Name: hd(anyarray); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION hd(anyarray) RETURNS anyelement
    AS $_$
DECLARE
  xs ALIAS FOR $1;
BEGIN
  RETURN xs[1];
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.hd(anyarray) OWNER TO postgres;

--
-- Name: label_abs_eq(label, label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_abs_eq(label, label) RETURNS boolean
    AS '/Users/b/links/selinks/branches/fable/pgsql/label', 'label_abs_eq'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.label_abs_eq(label, label) OWNER TO postgres;

--
-- Name: label_abs_neq(label, label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_abs_neq(label, label) RETURNS boolean
    AS '/Users/b/links/selinks/branches/fable/pgsql/label', 'label_abs_neq'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.label_abs_neq(label, label) OWNER TO postgres;

--
-- Name: label_get_arg(label, integer); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_get_arg(label, integer) RETURNS label
    AS '/Users/b/links/selinks/branches/fable/pgsql/label', 'label_get_arg'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.label_get_arg(label, integer) OWNER TO postgres;

--
-- Name: label_get_args(label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_get_args(label) RETURNS label[]
    AS $_$
DECLARE 
  l ALIAS FOR $1;
  a _label = null;
  i integer;
  n integer;
BEGIN
  i := 0;
  n := label_num_args(l);
  WHILE i < n LOOP        
    a := a || label_get_arg(l,i);
    i := i + 1;
  END LOOP;
  RETURN a;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.label_get_args(label) OWNER TO postgres;

--
-- Name: label_get_name(label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_get_name(label) RETURNS text
    AS '/Users/b/links/selinks/branches/fable/pgsql/label', 'label_get_name'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.label_get_name(label) OWNER TO postgres;

--
-- Name: label_num_args(label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION label_num_args(label) RETURNS integer
    AS '/Users/b/links/selinks/branches/fable/pgsql/label', 'label_num_args'
    LANGUAGE c IMMUTABLE STRICT;


ALTER FUNCTION public.label_num_args(label) OWNER TO postgres;

--
-- Name: member(label, label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION member(label, label) RETURNS label
    AS $_$
DECLARE
  u ALIAS FOR $1;
  a ALIAS FOR $2;
  v label;
  tl label;
  result label;
BEGIN
  IF a = 'Acl(_,_)' THEN
    v  := label_get_arg(a,0);
    tl := label_get_arg(a,1);
    IF u = v THEN 
      return 'Member';
    ELSE 
      result := member(u, tl);
      return result;
    END IF;
  ELSE return 'NotMember';
  END IF;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.member(label, label) OWNER TO postgres;

--
-- Name: simple_member(label, label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION simple_member(label, label) RETURNS label
    AS $_$
DECLARE
  u_g18 ALIAS FOR $1;
  a_g19 ALIAS FOR $2;
  _g5_g16 _label;
  _g7_g14 label;
  _g6_g15 _label;
  _g9_g12 label;
  _g8_g13 _label;
  res_g11 label;
BEGIN
  IF label_get_name(a_g19) = 'Acl' THEN
    _g5_g16 := label_get_args(a_g19);
    _g7_g14 := hd(_g5_g16);
    _g6_g15 := tl(_g5_g16);
    _g9_g12 := hd(_g6_g15);
    _g8_g13 := tl(_g6_g15);
    IF u_g18 = _g7_g14 THEN
      RETURN 'Member';
    ELSE
      res_g11 := simple_member(u_g18,_g9_g12);
      RETURN res_g11;
    END IF;
  ELSE
    RETURN 'NotMember';
  END IF;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.simple_member(label, label) OWNER TO postgres;

--
-- Name: test_proc(label); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION test_proc(label) RETURNS text
    AS $_$
DECLARE
  x_g863 ALIAS FOR $1;
  _g839_g861 _label;
  _g841_g859 label;
  _g840_g860 _label;
  _g843_g857 _label;
  _g845_g855 label;
  _g844_g856 _label;
  _g847_g853 _label;
BEGIN
  IF label_get_name(x_g863) = 'Cons' THEN
    _g839_g861 := label_get_args(x_g863);
    _g841_g859 := hd(_g839_g861);
    _g840_g860 := tl(_g839_g861);
    IF label_get_name(_g841_g859) = 'Foo' THEN
      _g843_g857 := label_get_args(_g841_g859);
      _g845_g855 := hd(_g840_g860);
      _g844_g856 := tl(_g840_g860);
      IF label_get_name(_g845_g855) = 'Nil' THEN
        _g847_g853 := label_get_args(_g845_g855);
        RETURN 'candy';
      ELSE
        RETURN 'buzz';
      END IF;
    ELSE
      RETURN 'buzz';
    END IF;
  ELSE
    RETURN 'buzz';
  END IF;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.test_proc(label) OWNER TO postgres;

--
-- Name: tl(anyarray); Type: FUNCTION; Schema: public; Owner: selinks
--

CREATE FUNCTION tl(anyarray) RETURNS anyarray
    AS $_$
DECLARE
  xs ALIAS FOR $1;
BEGIN
  RETURN xs[2:array_upper(xs,1)];
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public.tl(anyarray) OWNER TO postgres;

--
-- Name: <>; Type: OPERATOR; Schema: public; Owner: selinks
--

CREATE OPERATOR <> (
    PROCEDURE = label_abs_neq,
    LEFTARG = label,
    RIGHTARG = label,
    COMMUTATOR = <>,
    NEGATOR = =,
    RESTRICT = neqsel,
    JOIN = neqjoinsel
);


ALTER OPERATOR public.<> (label, label) OWNER TO postgres;

--
-- Name: =; Type: OPERATOR; Schema: public; Owner: selinks
--

CREATE OPERATOR = (
    PROCEDURE = label_abs_eq,
    LEFTARG = label,
    RIGHTARG = label,
    COMMUTATOR = =,
    NEGATOR = <>,
    RESTRICT = eqsel,
    JOIN = eqjoinsel
);


ALTER OPERATOR public.= (label, label) OWNER TO postgres;

--
-- Name: label_abs_ops; Type: OPERATOR CLASS; Schema: public; Owner: selinks
--

CREATE OPERATOR CLASS label_abs_ops
    DEFAULT FOR TYPE label USING btree AS
    OPERATOR 1 =(label,label) ,
    OPERATOR 2 <>(label,label);


ALTER OPERATOR CLASS public.label_abs_ops USING btree OWNER TO postgres;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: block_format; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE block_format (
    pageid integer NOT NULL,
    blockid integer NOT NULL,
    formattag character varying(1024),
    userid integer NOT NULL
);


ALTER TABLE public.block_format OWNER TO postgres;

--
-- Name: block_label; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE block_label (
    pageid integer NOT NULL,
    blockid integer NOT NULL,
    label text
);


ALTER TABLE public.block_label OWNER TO postgres;

--
-- Name: blockid_sequence; Type: SEQUENCE; Schema: public; Owner: selinks
--

CREATE SEQUENCE blockid_sequence
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.blockid_sequence OWNER TO postgres;

--
-- Name: blockid_sequence; Type: SEQUENCE SET; Schema: public; Owner: selinks
--

SELECT pg_catalog.setval('blockid_sequence', 26288, true);


--
-- Name: favorite_books; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE favorite_books (
    employee_id integer,
    books text[]
);


ALTER TABLE public.favorite_books OWNER TO postgres;

--
-- Name: lusers; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE lusers (
    name character varying(32),
    lab label
);


ALTER TABLE public.lusers OWNER TO postgres;

--
-- Name: page_blocks; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE page_blocks (
    blockid integer DEFAULT nextval('blockid_sequence'::regclass) NOT NULL,
    pageid integer NOT NULL,
    parentblockid integer,
    blocktype character varying(32) NOT NULL,
    text text,
    sibling integer,
    current boolean,
    label label,
    CONSTRAINT page_blocks_blocktype_check CHECK (((blocktype)::text = ANY ((ARRAY['formatted'::character varying, 'labeled'::character varying, 'word'::character varying, 'compound'::character varying])::text[])))
);


ALTER TABLE public.page_blocks OWNER TO postgres;

--
-- Name: pageid_sequence; Type: SEQUENCE; Schema: public; Owner: selinks
--

CREATE SEQUENCE pageid_sequence
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.pageid_sequence OWNER TO postgres;

--
-- Name: pageid_sequence; Type: SEQUENCE SET; Schema: public; Owner: selinks
--

SELECT pg_catalog.setval('pageid_sequence', 814, true);


--
-- Name: pages; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE pages (
    pageid integer DEFAULT nextval('pageid_sequence'::regclass) NOT NULL,
    creator integer,
    title character varying(64)
);


ALTER TABLE public.pages OWNER TO postgres;

--
-- Name: stuff; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE stuff (
    id integer,
    data_l label,
    data character varying(32)
);


ALTER TABLE public.stuff OWNER TO postgres;

--
-- Name: tag_user_xref; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE tag_user_xref (
    tagid integer NOT NULL,
    userid integer NOT NULL
);


ALTER TABLE public.tag_user_xref OWNER TO postgres;

--
-- Name: tags; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE tags (
    tagid integer NOT NULL,
    "owner" integer,
    name character varying(80)
);


ALTER TABLE public.tags OWNER TO postgres;

--
-- Name: tags_tagid_seq; Type: SEQUENCE; Schema: public; Owner: selinks
--

CREATE SEQUENCE tags_tagid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.tags_tagid_seq OWNER TO postgres;

--
-- Name: tags_tagid_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: selinks
--

ALTER SEQUENCE tags_tagid_seq OWNED BY tags.tagid;


--
-- Name: tags_tagid_seq; Type: SEQUENCE SET; Schema: public; Owner: selinks
--

SELECT pg_catalog.setval('tags_tagid_seq', 6, true);


--
-- Name: test_label; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE test_label (
    a label,
    b label
);


ALTER TABLE public.test_label OWNER TO postgres;

--
-- Name: userid_sequence; Type: SEQUENCE; Schema: public; Owner: selinks
--

CREATE SEQUENCE userid_sequence
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.userid_sequence OWNER TO postgres;

--
-- Name: userid_sequence; Type: SEQUENCE SET; Schema: public; Owner: selinks
--

SELECT pg_catalog.setval('userid_sequence', 34, true);


--
-- Name: users; Type: TABLE; Schema: public; Owner: selinks; Tablespace: 
--

CREATE TABLE users (
    name character varying(30),
    "password" character varying(30),
    credential integer,
    userid integer DEFAULT nextval('userid_sequence'::regclass) NOT NULL
);


ALTER TABLE public.users OWNER TO postgres;

--
-- Name: tagid; Type: DEFAULT; Schema: public; Owner: selinks
--

ALTER TABLE tags ALTER COLUMN tagid SET DEFAULT nextval('tags_tagid_seq'::regclass);


--
-- Data for Name: block_format; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY block_format (pageid, blockid, formattag, userid) FROM stdin;
765	19281	BAJXUwQEUGFyYQMA	1
765	19284	BAJXUwQEUGFyYQMA	1
776	20330	BARFbXBoAwA=	30
776	20333	BAJXUwQEUGFyYQMA	30
776	20336	BAJXUwQEUGFyYQMA	30
776	20339	BARCb2xkAwA=	30
776	20342	BARFbXBoAwA=	30
776	20345	BARCb2xkAwA=	30
776	20348	BARCb2xkAwA=	30
776	20351	BAJXUwQEUGFyYQMA	30
776	20356	BARMaW5rBgkIAWMIAXAIAWEIAS4IAWwIAWkIAW4IAWsIAXM=	30
776	20359	BARFbXBoAwA=	30
776	20362	BAJXUwQEUGFyYQMA	30
776	20365	BAhXaWtpTGluawMA	30
776	20367	BAJXUwQEUGFyYQMA	30
780	20797	BAJXUwQEUGFyYQMA	30
780	20802	BARMaXN0AwA=	30
780	20804	BAZJbmRlbnQIBQEw	30
780	20805	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
780	20807	BAhXaWtpTGluawMA	30
780	20811	BAZJbmRlbnQIBQEw	30
780	20812	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
780	20814	BAhXaWtpTGluawMA	30
780	20818	BAZJbmRlbnQIBQEw	30
780	20819	BApPcmRlcmVkRWx0BgIIATMIAS4=	30
780	20821	BAhXaWtpTGluawMA	30
782	20853	BARMaW5rBjEIAWgIAXQIAXQIAXAIAToIAS8IAS8IAXcIAXcIAXcIAS4IAWMIAXMIAS4IAXUIAW0IAWQIAS4IAWUIAWQIAXUIAS8IAX4IAW4IAXMIAXcIAWEIAW0IAXkIAS8IAXAIAWEIAXAIAWUIAXIIAXMIAS8IAWYIAWEIAWIIAWwIAWUIAS0IAXQIAXIIAS4IAXAIAWQIAWY=	30
782	20856	BARFbXBoAwA=	30
782	20859	BARFbXBoAwA=	30
782	20862	BAJXUwQEUGFyYQMA	30
782	20865	BAhXaWtpTGluawMA	30
783	20941	BARIZHIyAwA=	1
783	20943	BAJXUwQEUGFyYQMA	1
783	20948	BAJXUwQEUGFyYQMA	1
783	20950	BARIZHIyAwA=	1
783	20952	BAJXUwQEUGFyYQMA	1
783	20957	BAJXUwQEUGFyYQMA	1
783	20960	BARFbXBoAwA=	1
783	20963	BARFbXBoAwA=	1
783	20966	BAJXUwQEUGFyYQMA	1
783	20969	BAJXUwQEUGFyYQMA	1
783	20972	BAhXaWtpTGluawMA	1
781	21217	BARMaW5rBhMIAWgIAXQIAXQIAXAIAToIAS8IAS8IAXcIAXcIAXcIAS4IAWUIAWQIAS4IAWEIAWMIAS4IAXUIAWs=	1
781	21220	BAJXUwQEUGFyYQMA	1
781	21229	BAJXUwQEUGFyYQMA	1
781	21232	BARMaW5rBiEIAWgIAXQIAXQIAXAIAToIAS8IAS8IAWcIAXIIAW8IAXUIAXAIAXMIAS4IAWkIAW4IAWYIAS4IAWUIAWQIAS4IAWEIAWMIAS4IAXUIAWsIAS8IAWwIAWkIAW4IAWsIAXMIAS8=	1
781	21235	BAJXUwQEUGFyYQMA	1
781	21238	BAhXaWtpTGluawMA	1
784	21244	BAJXUwQEUGFyYQMA	30
784	21249	BARMaXN0AwA=	30
784	21251	BAZJbmRlbnQIBQEw	30
784	21252	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
784	21254	BAhXaWtpTGluawMA	30
784	21258	BAZJbmRlbnQIBQEw	30
784	21259	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
784	21261	BAhXaWtpTGluawMA	30
784	21265	BAZJbmRlbnQIBQEw	30
784	21266	BApPcmRlcmVkRWx0BgIIATMIAS4=	30
784	21268	BAhXaWtpTGluawMA	30
784	21272	BAZJbmRlbnQIBQEw	30
784	21273	BApPcmRlcmVkRWx0BgIIATQIAS4=	30
784	21275	BAhXaWtpTGluawMA	30
784	21279	BAZJbmRlbnQIBQEw	30
784	21280	BApPcmRlcmVkRWx0BgIIATUIAS4=	30
784	21282	BAhXaWtpTGluawMA	30
784	21286	BAJXUwQEUGFyYQMA	30
788	22403	BAJXUwQEUGFyYQMA	30
788	22408	BARMaXN0AwA=	30
788	22410	BAZJbmRlbnQIBQEw	30
788	22411	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
788	22416	BAZJbmRlbnQIBQEw	30
788	22417	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
788	22422	BAJXUwQEUGFyYQMA	30
788	22425	BAJXUwQEUGFyYQMA	30
788	22427	BARIZHIyAwA=	30
788	22429	BAJXUwQEUGFyYQMA	30
788	22432	BAJXUwQEUGFyYQMA	30
788	22437	BApCbG9ja1F1b3RlAwA=	30
788	22442	BAhXaWtpTGluawMA	30
788	22444	BAJXUwQEUGFyYQMA	30
788	22447	BAJXUwQEUGFyYQMA	30
788	22449	BARIZHIyAwA=	30
788	22451	BAJXUwQEUGFyYQMA	30
788	22454	BAJXUwQEUGFyYQMA	30
788	22459	BApCbG9ja1F1b3RlAwA=	30
788	22464	BARMaW5rBhYIAWgIAXQIAXQIAXAIAToIAS8IAS8IAXcIAXcIAXcIAS4IAWcIAW8IAW8IAWcIAWwIAWUIAS4IAWMIAW8IAW0IAS8=	30
788	22466	BAJXUwQEUGFyYQMA	30
788	22469	BAJXUwQEUGFyYQMA	30
788	22474	BApCbG9ja1F1b3RlAwA=	30
788	22480	BARMaW5rBh4IAWgIAXQIAXQIAXAIAXMIAToIAS8IAS8IAXcIAXcIAXcIAS4IAWIIAWEIAW4IAWsIAW8IAWYIAWEIAW0IAWUIAXIIAWkIAWMIAWEIAS4IAWMIAW8IAW0IAS8=	30
788	22482	BAJXUwQEUGFyYQMA	30
788	22484	BARMaW5rBhUIAW0IAWEIAWkIAWwIAXQIAW8IAToIAWIIAWoIAWMIAUAIAWMIAXMIAS4IAXUIAW0IAWQIAS4IAWUIAWQIAXU=	30
788	22486	BAJXUwQEUGFyYQMA	30
788	22488	BAJXUwQFSExpbmUDAA==	30
788	22490	BAJXUwQEUGFyYQMA	30
788	22493	BAhXaWtpTGluawMA	30
788	22496	BAJXUwQEUGFyYQMA	30
790	23693	BAJXUwQEUGFyYQMA	30
790	23698	BARMaXN0AwA=	30
790	23700	BAZJbmRlbnQIBQEw	30
790	23701	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23706	BAZJbmRlbnQIBQEw	30
790	23707	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23712	BAZJbmRlbnQIBQEw	30
790	23713	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23718	BAZJbmRlbnQIBQEw	30
790	23719	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23726	BARIZHIyAwA=	30
790	23728	BAJXUwQEUGFyYQMA	30
790	23731	BAJXUwQEUGFyYQMA	30
790	23736	BApCbG9ja1F1b3RlAwA=	30
790	23741	BAlJbWFnZUxpbmsGNAgBaAgBdAgBdAgBcAgBOggBLwgBLwgBdwgBdwgBdwgBLggBYwgBcwgBLggBdQgBbQgBZAgBLggBZQgBZAgBdQgBLwgBYQgBcwgBcwgBZQgBdAgBcwgBLwgBaQgBbQgBYQgBZwgBZQgBcwgBLwgBbAgBbwgBZwgBbwgBcwgBLwgBZwgBbAgBbwgBYggBZQgBMggBLggBZwgBaQgBZg==	30
790	23743	BAJXUwQEUGFyYQMA	30
790	23746	BARFbXBoAwA=	30
790	23753	BAJXUwQEUGFyYQMA	30
790	23755	BARIZHIyAwA=	30
790	23757	BAJXUwQEUGFyYQMA	30
790	23759	BARCb2xkAwA=	30
790	23762	BAJXUwQEUGFyYQMA	30
790	23765	BAJXUwQEUGFyYQMA	30
790	23768	BAJXUwQEUGFyYQMA	30
790	23773	BApCbG9ja1F1b3RlAwA=	30
790	23777	BAJXUwQEUGFyYQMA	30
790	23782	BARMaXN0AwA=	30
790	23784	BAZJbmRlbnQIBQEw	30
790	23785	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23790	BAZJbmRlbnQIBQEw	30
790	23791	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23796	BAJXUwQEUGFyYQMA	30
790	23801	BApCbG9ja1F1b3RlAwA=	30
790	23805	BAJXUwQEUGFyYQMA	30
790	23810	BARMaXN0AwA=	30
790	23812	BAZJbmRlbnQIBQEw	30
790	23813	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
790	23818	BAZJbmRlbnQIBQEw	30
790	23819	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
790	23824	BAJXUwQEUGFyYQMA	30
790	23831	BAJXUwQEUGFyYQMA	30
790	23836	BApCbG9ja1F1b3RlAwA=	30
790	23843	BAJXUwQEUGFyYQMA	30
790	23848	BARMaXN0AwA=	30
790	23850	BAZJbmRlbnQIBQEw	30
790	23851	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
790	23856	BAZJbmRlbnQIBQEx	30
790	23857	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23862	BAZJbmRlbnQIBQEx	30
790	23863	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
790	23868	BAZJbmRlbnQIBQEw	30
790	23869	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
790	23874	BAZJbmRlbnQIBQEw	30
790	23875	BApPcmRlcmVkRWx0BgIIATMIAS4=	30
790	23880	BAJXUwQEUGFyYQMA	30
790	23882	BARIZHIyAwA=	30
790	23884	BAJXUwQEUGFyYQMA	30
790	23887	BAJXUwQEUGFyYQMA	30
790	23892	BApCbG9ja1F1b3RlAwA=	30
790	23897	BAJXUwQFSExpbmUDAA==	30
790	23899	BAJXUwQEUGFyYQMA	30
790	23903	BARIZHIyAwA=	30
790	23905	BAJXUwQEUGFyYQMA	30
790	23908	BARFbXBoAwA=	30
790	23913	BAJXUwQEUGFyYQMA	30
790	23918	BApCbG9ja1F1b3RlAwA=	30
790	23921	BAJXUwQEUGFyYQMA	30
790	23926	BApCbG9ja1F1b3RlAwA=	30
790	23931	BAJXUwQFSExpbmUDAA==	30
790	23933	BAJXUwQEUGFyYQMA	30
790	23938	BAhXaWtpTGluawMA	30
792	24055	BARCb2xkAwA=	1
792	24058	BAJXUwQEUGFyYQMA	1
792	24061	BARCb2xkAwA=	1
792	24064	BAJXUwQEUGFyYQMA	1
792	24068	BAJXUwQEUGFyYQMA	1
792	24073	BARFbXBoAwA=	1
792	24076	BARCb2xkAwA=	1
792	24079	BAJXUwQEUGFyYQMA	1
792	24081	BAJXUwQFSExpbmUDAA==	1
792	24083	BAJXUwQEUGFyYQMA	1
792	24086	BAhXaWtpTGluawMA	1
786	24544	BARIZHIxAwA=	1
786	24546	BAJXUwQEUGFyYQMA	1
786	24549	BAJXUwQEUGFyYQMA	1
786	24552	BARMaW5rBgkIAWMIAXAIAWEIAS4IAWwIAWkIAW4IAWsIAXM=	1
786	24555	BARFbXBoAwA=	1
786	24558	BARFbXBoAwA=	1
786	24561	BAJXUwQEUGFyYQMA	1
786	24563	BARIZHIyAwA=	1
786	24565	BAJXUwQEUGFyYQMA	1
786	24568	BARCb2xkAwA=	1
786	24571	BARFbXBoAwA=	1
786	24574	BARCb2xkAwA=	1
786	24577	BAJXUwQEUGFyYQMA	1
786	24580	BAJXUwQEUGFyYQMA	1
786	24582	BARIZHIyAwA=	1
786	24584	BAJXUwQEUGFyYQMA	1
786	24587	BARCb2xkAwA=	1
786	24590	BARCb2xkAwA=	1
786	24593	BAJXUwQEUGFyYQMA	1
786	24596	BARCb2xkAwA=	1
786	24599	BAJXUwQEUGFyYQMA	1
786	24602	BAhXaWtpTGluawMA	1
787	25063	BAJXUwQEUGFyYQMA	1
787	25065	BARIZHIxAwA=	1
787	25067	BAJXUwQEUGFyYQMA	1
787	25069	BARIZHIyAwA=	1
787	25071	BAJXUwQEUGFyYQMA	1
787	25074	BAJXUwQEUGFyYQMA	1
787	25079	BApCbG9ja1F1b3RlAwA=	1
787	25084	BARFbXBoAwA=	1
787	25087	BARFbXBoAwA=	1
787	25089	BAJXUwQEUGFyYQMA	1
787	25091	BARIZHIyAwA=	1
787	25093	BAJXUwQEUGFyYQMA	1
787	25096	BAJXUwQEUGFyYQMA	1
787	25101	BApCbG9ja1F1b3RlAwA=	1
787	25106	BARCb2xkAwA=	1
787	25108	BAJXUwQEUGFyYQMA	1
787	25110	BARIZHIyAwA=	1
787	25112	BAJXUwQEUGFyYQMA	1
787	25115	BAJXUwQEUGFyYQMA	1
787	25120	BApCbG9ja1F1b3RlAwA=	1
787	25125	BANEZWwDAA==	1
787	25127	BAJXUwQEUGFyYQMA	1
787	25129	BARIZHIyAwA=	1
787	25131	BAJXUwQEUGFyYQMA	1
787	25134	BAJXUwQEUGFyYQMA	1
787	25139	BApCbG9ja1F1b3RlAwA=	1
787	25144	BANTdXADAA==	1
787	25147	BANTdWIDAA==	1
787	25149	BAJXUwQEUGFyYQMA	1
787	25151	BARIZHIyAwA=	1
787	25153	BAJXUwQEUGFyYQMA	1
787	25156	BAJXUwQEUGFyYQMA	1
787	25161	BApCbG9ja1F1b3RlAwA=	1
787	25166	BARIZHIxAwA=	1
787	25168	BAJXUwQEUGFyYQMA	1
787	25173	BApCbG9ja1F1b3RlAwA=	1
787	25178	BARIZHIyAwA=	1
787	25180	BAJXUwQEUGFyYQMA	1
787	25182	BARIZHIxAwA=	1
787	25186	BAJXUwQEUGFyYQMA	1
787	25189	BARCb2xkAwA=	1
787	25192	BARCb2xkAwA=	1
787	25195	BAJXUwQEUGFyYQMA	1
787	25198	BAhXaWtpTGluawMA	1
787	25201	BAJXUwQEUGFyYQMA	1
787	25203	BAJXUwQEUGFyYQMA	1
801	25214	BAJXUwQEUGFyYQMA	30
801	25219	BARMaXN0AwA=	30
801	25221	BAZJbmRlbnQIBQEw	30
801	25222	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
801	25227	BAZJbmRlbnQIBQEw	30
801	25228	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
801	25236	BAJXUwQEUGFyYQMA	30
801	25238	BARIZHIxAwA=	30
801	25240	BAJXUwQEUGFyYQMA	30
801	25245	BARFbXBoAwA=	30
801	25248	BARFbXBoAwA=	30
801	25251	BARFbXBoAwA=	30
801	25254	BAJXUwQEUGFyYQMA	30
801	25259	BApCbG9ja1F1b3RlAwA=	30
801	25265	BARFbXBoAwA=	30
801	25268	BARFbXBoAwA=	30
801	25271	BARFbXBoAwA=	30
801	25274	BARFbXBoAwA=	30
801	25277	BARFbXBoAwA=	30
801	25280	BARFbXBoAwA=	30
801	25283	BARFbXBoAwA=	30
801	25286	BAJXUwQEUGFyYQMA	30
801	25288	BARIZHIxAwA=	30
801	25290	BAJXUwQEUGFyYQMA	30
801	25293	BAJXUwQEUGFyYQMA	30
801	25296	BARFbXBoAwA=	30
801	25299	BAJXUwQEUGFyYQMA	30
801	25302	BAJXUwQEUGFyYQMA	30
801	25305	BAJXUwQEUGFyYQMA	30
801	25310	BApCbG9ja1F1b3RlAwA=	30
801	25320	BAhXaWtpTGluawMA	30
801	25322	BAJXUwQEUGFyYQMA	30
802	25456	BARCb2xkAwA=	1
802	25459	BARCb2xkAwA=	1
802	25462	BARFbXBoAwA=	1
802	25465	BARCb2xkAwA=	1
802	25468	BAJXUwQEUGFyYQMA	1
802	25471	BARCb2xkAwA=	1
802	25474	BARFbXBoAwA=	1
802	25479	BARFbXBoAwA=	1
802	25482	BARFbXBoAwA=	1
802	25485	BAJXUwQEUGFyYQMA	1
802	25488	BARFbXBoAwA=	1
802	25491	BARFbXBoAwA=	1
802	25494	BARFbXBoAwA=	1
802	25497	BARFbXBoAwA=	1
802	25500	BAJXUwQEUGFyYQMA	1
802	25503	BARFbXBoAwA=	1
802	25506	BARFbXBoAwA=	1
802	25509	BAJXUwQEUGFyYQMA	1
802	25512	BAhXaWtpTGluawMA	1
802	25515	BAJXUwQEUGFyYQMA	1
803	25521	BARCb2xkAwA=	30
803	25524	BARCb2xkAwA=	30
803	25527	BARCb2xkAwA=	30
803	25530	BARCb2xkAwA=	30
803	25533	BAJXUwQEUGFyYQMA	30
803	25536	BARFbXBoAwA=	30
803	25539	BAJXUwQEUGFyYQMA	30
803	25544	BApCbG9ja1F1b3RlAwA=	30
803	25554	BAhXaWtpTGluawMA	30
803	25556	BAJXUwQEUGFyYQMA	30
804	25562	BARCb2xkAwA=	30
804	25565	BARCb2xkAwA=	30
804	25568	BAJXUwQEUGFyYQMA	30
804	25571	BARFbXBoAwA=	30
804	25577	BARFbXBoAwA=	30
804	25583	BARFbXBoAwA=	30
804	25589	BARCb2xkAwA=	30
804	25592	BAJXUwQEUGFyYQMA	30
804	25595	BARCb2xkAwA=	30
804	25598	BAJXUwQEUGFyYQMA	30
804	25603	BApCbG9ja1F1b3RlAwA=	30
804	25613	BARFbXBoAwA=	30
804	25616	BAJXUwQEUGFyYQMA	30
804	25619	BAhXaWtpTGluawMA	30
804	25621	BAJXUwQEUGFyYQMA	30
805	25627	BAJXUwQEUGFyYQMA	30
805	25632	BARMaXN0AwA=	30
805	25634	BAZJbmRlbnQIBQEw	30
805	25635	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
805	25638	BARCb2xkAwA=	30
805	25642	BAZJbmRlbnQIBQEw	30
805	25643	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
805	25646	BARFbXBoAwA=	30
805	25651	BAZJbmRlbnQIBQEw	30
805	25652	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
805	25655	BARCb2xkAwA=	30
805	25659	BAZJbmRlbnQIBQEw	30
805	25660	BAxVbm9yZGVyZWRFbHQGAQgBKg==	30
805	25663	BARCb2xkAwA=	30
805	25670	BARFbXBoAwA=	30
805	25673	BARFbXBoAwA=	30
805	25676	BARFbXBoAwA=	30
805	25679	BAJXUwQEUGFyYQMA	30
805	25682	BARFbXBoAwA=	30
805	25685	BARFbXBoAwA=	30
805	25688	BAJXUwQEUGFyYQMA	30
805	25691	BARCb2xkAwA=	30
805	25694	BARCb2xkAwA=	30
805	25697	BARCb2xkAwA=	30
805	25700	BAJXUwQEUGFyYQMA	30
805	25708	BARFbXBoAwA=	30
805	25711	BARFbXBoAwA=	30
805	25716	BAJXUwQEUGFyYQMA	30
805	25719	BAhXaWtpTGluawMA	30
807	25762	BARFbXBoAwA=	30
807	25765	BARCb2xkAwA=	30
807	25768	BARCb2xkAwA=	30
807	25771	BAJXUwQEUGFyYQMA	30
807	25774	BARCb2xkAwA=	30
807	25777	BARFbXBoAwA=	30
807	25780	BAJXUwQEUGFyYQMA	30
807	25783	BAhXaWtpTGluawMA	30
807	25786	BAJXUwQEUGFyYQMA	30
806	25824	BAJXUwQEUGFyYQMA	1
806	25827	BARCb2xkAwA=	1
806	25830	BARFbXBoAwA=	1
806	25833	BARFbXBoAwA=	1
806	25836	BARCb2xkAwA=	1
806	25839	BARCb2xkAwA=	1
806	25842	BAJXUwQEUGFyYQMA	1
806	25844	BAJXUwQFSExpbmUDAA==	1
806	25848	BAhXaWtpTGluawMA	1
806	25850	BAJXUwQEUGFyYQMA	1
808	25856	BAJXUwQEUGFyYQMA	30
808	25861	BARMaXN0AwA=	30
808	25863	BAZJbmRlbnQIBQEw	30
808	25864	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
808	25866	BAhXaWtpTGluawMA	30
808	25870	BAZJbmRlbnQIBQEw	30
808	25871	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
808	25873	BAhXaWtpTGluawMA	30
808	25877	BAZJbmRlbnQIBQEx	30
808	25878	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
808	25880	BAhXaWtpTGluawMA	30
808	25884	BAZJbmRlbnQIBQEx	30
808	25885	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
808	25887	BAhXaWtpTGluawMA	30
808	25891	BAZJbmRlbnQIBQEx	30
808	25892	BApPcmRlcmVkRWx0BgIIATMIAS4=	30
808	25894	BAhXaWtpTGluawMA	30
808	25898	BAZJbmRlbnQIBQEw	30
808	25899	BApPcmRlcmVkRWx0BgIIATMIAS4=	30
808	25901	BAhXaWtpTGluawMA	30
808	25905	BAZJbmRlbnQIBQEx	30
808	25906	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
808	25908	BAhXaWtpTGluawMA	30
808	25912	BAZJbmRlbnQIBQEx	30
808	25913	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
808	25915	BAhXaWtpTGluawMA	30
808	25919	BAZJbmRlbnQIBQEx	30
808	25920	BApPcmRlcmVkRWx0BgIIATMIAS4=	30
808	25922	BAhXaWtpTGluawMA	30
808	25926	BAZJbmRlbnQIBQEx	30
808	25927	BApPcmRlcmVkRWx0BgIIATQIAS4=	30
808	25929	BAhXaWtpTGluawMA	30
808	25933	BAZJbmRlbnQIBQEx	30
808	25934	BApPcmRlcmVkRWx0BgIIATUIAS4=	30
808	25936	BAhXaWtpTGluawMA	30
808	25940	BAZJbmRlbnQIBQEw	30
808	25941	BApPcmRlcmVkRWx0BgIIATQIAS4=	30
808	25943	BAhXaWtpTGluawMA	30
808	25947	BAZJbmRlbnQIBQEx	30
808	25948	BApPcmRlcmVkRWx0BgIIATEIAS4=	30
808	25950	BAhXaWtpTGluawMA	30
808	25954	BAZJbmRlbnQIBQEx	30
808	25955	BApPcmRlcmVkRWx0BgIIATIIAS4=	30
808	25957	BAhXaWtpTGluawMA	30
808	25961	BAZJbmRlbnQIBQEx	30
808	25962	BApPcmRlcmVkRWx0BgIIATMIAS4=	30
808	25964	BAhXaWtpTGluawMA	30
808	25968	BAZJbmRlbnQIBQEx	30
808	25969	BApPcmRlcmVkRWx0BgIIATQIAS4=	30
808	25971	BAhXaWtpTGluawMA	30
808	25975	BAZJbmRlbnQIBQEx	30
808	25976	BApPcmRlcmVkRWx0BgIIATUIAS4=	30
808	25978	BAhXaWtpTGluawMA	30
808	25982	BAZJbmRlbnQIBQEw	30
808	25983	BApPcmRlcmVkRWx0BgIIATUIAS4=	30
808	25985	BAhXaWtpTGluawMA	30
808	25989	BAJXUwQEUGFyYQMA	30
808	25992	BAhXaWtpTGluawMA	30
813	26266	BAJXUwQEUGFyYQMA	1
\.


--
-- Data for Name: block_label; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY block_label (pageid, blockid, label) FROM stdin;
765	19278	SECURITY[PROV[ACTIONS[ACTION_20070817192703[MODIFY[USER[Brian],DATE[2007-08-17],TIME[15:27:03],DESC[Path:.->!]]],ACTION_20070817192605[CREATE[USER[Brian],TIME[15:26:05],DESC[SELinksDemoRestricted],DATE[2007-08-17]]]]],ACL[WRITE[authors],READ[guests]]]
765	19287	SECURITY[PROV[ACTIONS[ACTION_20070817192729[RELABEL[DESC[ACL{WRITE{administrators};READ{administrators}}],TIME[15:27:29],DATE[2007-08-17],USER[Brian]]]]],ACL[WRITE[administrators],READ[administrators]]]
765	19289	SECURITY[PROV[ACTIONS[ACTION_20070817192746[RELABEL[DESC[ACL{WRITE{administrators};READ{guests}}],TIME[15:27:46],DATE[2007-08-17],USER[Brian]]]]],ACL[WRITE[administrators],READ[guests]]]
776	20326	SECURITY[PROV[ACTIONS[ACTION_20070825034146[CREATE[DESC[*Start Here*],TIME[23:41:46],DATE[2007-08-24],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
780	20793	SECURITY[PROV[ACTIONS[ACTION_20070825035543[CREATE[DESC[Demo 2 Background],TIME[23:55:43],DATE[2007-08-24],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
782	20847	SECURITY[PROV[ACTIONS[ACTION_20070825040815[CREATE[DESC[Demo 2b SElinks],TIME[00:08:15],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
783	20939	SECURITY[PROV[ACTIONS[ACTION_20070825041619[CREATE[DESC[Demo2cCPAWiki],TIME[00:15:39],DATE[2007-08-25],USER[Brian]]],ACTION_20070825041619[MODIFY[DESC[Path:.->!],TIME[00:16:16],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
781	21214	SECURITY[PROV[ACTIONS[ACTION_20070825042112[CREATE[DESC[Demo2aLinks],TIME[00:02:04],DATE[2007-08-25],USER[Brian]]],ACTION_20070825042112[MODIFY[DESC[Path:.->!],TIME[00:17:17],DATE[2007-08-25],USER[Brian]]],ACTION_20070825042112[MODIFY[DESC[Path:.->!],TIME[00:17:52],DATE[2007-08-25],USER[Brian]]],ACTION_20070825042112[MODIFY[DESC[Path:.->!],TIME[00:18:51],DATE[2007-08-25],USER[Brian]]],ACTION_20070825042112[MODIFY[DESC[Path:.->!],TIME[00:19:21],DATE[2007-08-25],USER[Brian]]],ACTION_20070825042112[MODIFY[DESC[Path:.->!],TIME[00:19:43],DATE[2007-08-25],USER[Brian]]],ACTION_20070825042112[MODIFY[DESC[Path:.->!],TIME[00:21:04],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
784	21240	SECURITY[PROV[ACTIONS[ACTION_20070825042348[CREATE[DESC[Demo 3 Wiki Features],TIME[00:23:48],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
788	22399	SECURITY[PROV[ACTIONS[ACTION_20070825141756[CREATE[DESC[Demo 3c URLs],TIME[10:17:55],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
790	23689	SECURITY[PROV[ACTIONS[ACTION_20070825144217[CREATE[DESC[Demo 3d Other Features],TIME[10:42:17],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
792	24050	SECURITY[PROV[ACTIONS[ACTION_20070825180818[CREATE[DESC[Demo3eCopyPaste],TIME[14:07:12],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
792	24052	SECURITY[PROV[ACTIONS[ACTION_20070825180819[CREATE[DESC[Demo3eCopyPaste],TIME[14:07:12],DATE[2007-08-25],USER[Brian]]],ACTION_20070825180819[MODIFY[DESC[Path:.->.0->!],TIME[14:07:50],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
792	24066	SECURITY[PROV[ACTIONS[ACTION_20070825180819[RELABEL[DESC[ACL{WRITE{guests;authors};READ{guests}}],TIME[14:07:26],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[guests,authors],READ[guests]]]
792	24070	SECURITY[PROV[ACTIONS[ACTION_20070825180819[CREATE[DESC[Demo3eCopyPaste],TIME[14:07:12],DATE[2007-08-25],USER[Brian]]],ACTION_20070825180819[MODIFY[DESC[Path:.->.4->!],TIME[14:08:14],DATE[2007-08-25],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
786	24542	SECURITY[PROV[ACTIONS[ACTION_20070827233726[CREATE[DESC[Demo3aTextEditing],TIME[09:55:28],DATE[2007-08-25],USER[Brian]]],ACTION_20070827233726[MODIFY[DESC[Path:.->!],TIME[19:37:21],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
787	25055	SECURITY[PROV[ACTIONS[ACTION_20070827233915[CREATE[DESC[Demo3bTextFormatting],TIME[10:04:21],DATE[2007-08-25],USER[Brian]]],ACTION_20070827233915[MODIFY[DESC[Path:.->!],TIME[10:05:11],DATE[2007-08-25],USER[Brian]]],ACTION_20070827233915[MODIFY[DESC[Path:.->!],TIME[10:06:29],DATE[2007-08-25],USER[Brian]]],ACTION_20070827233915[MODIFY[DESC[Path:.->!],TIME[10:07:01],DATE[2007-08-25],USER[Brian]]],ACTION_20070827233915[MODIFY[DESC[Path:.->!],TIME[19:38:03],DATE[2007-08-27],USER[Brian]]],ACTION_20070827233915[MODIFY[DESC[Path:.->!],TIME[19:39:03],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
801	25210	SECURITY[PROV[ACTIONS[ACTION_20070828020505[CREATE[DESC[Demo 4 Labels],TIME[22:05:05],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
802	25453	SECURITY[PROV[ACTIONS[ACTION_20070828020627[CREATE[DESC[Demo4aCreatingaPageRevisited],TIME[22:06:03],DATE[2007-08-27],USER[Brian]]],ACTION_20070828020627[MODIFY[DESC[Path:.->!],TIME[22:06:23],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
803	25517	SECURITY[PROV[ACTIONS[ACTION_20070828020743[CREATE[DESC[Demo 4b Modifying Content Revisted],TIME[22:07:43],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
804	25558	SECURITY[PROV[ACTIONS[ACTION_20070828021026[CREATE[DESC[Demo 4c Modifying Access Control],TIME[22:10:26],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
805	25623	SECURITY[PROV[ACTIONS[ACTION_20070828021255[CREATE[DESC[Demo 4e Access Control in Action],TIME[22:12:55],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
807	25756	SECURITY[PROV[ACTIONS[ACTION_20070828021658[CREATE[DESC[Demo 4d Copy Paste Revisited],TIME[22:16:58],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
806	25821	SECURITY[PROV[ACTIONS[ACTION_20070828021749[CREATE[DESC[Demo6Conclusion],TIME[22:13:55],DATE[2007-08-27],USER[Brian]]],ACTION_20070828021749[MODIFY[DESC[Path:.->!],TIME[22:17:46],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
808	25852	SECURITY[PROV[ACTIONS[ACTION_20070828022442[CREATE[DESC[Demo 1 Overview],TIME[22:24:42],DATE[2007-08-27],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
813	26263	SECURITY[PROV[ACTIONS[ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[14:32:41],DATE[2008-01-14],USER[Brian]]],ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[14:54:47],DATE[2008-01-14],USER[Brian]]],ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[15:14:59],DATE[2008-01-14],USER[Brian]]],ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[15:16:50],DATE[2008-01-14],USER[Brian]]],ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[15:18:15],DATE[2008-01-14],USER[Brian]]],ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[15:20:30],DATE[2008-01-14],USER[Brian]]],ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[15:22:29],DATE[2008-01-14],USER[Brian]]],ACTION_20080114203009[MODIFY[DESC[Path:.->!],TIME[15:30:01],DATE[2008-01-14],USER[Brian]]]]],ACL[WRITE[authors,administrators],READ[guests,authors]]]
814	26287	SECURITY[PROV[ACTIONS[ACTION_20080114230639[CREATE[DESC[Anewpage],TIME[17:47:47],DATE[2008-01-14],USER[Brian]]],ACTION_20080114230639[MODIFY[DESC[Path:.->!],TIME[17:48:51],DATE[2008-01-14],USER[Brian]]],ACTION_20080114230639[MODIFY[DESC[Path:.->!],TIME[17:49:43],DATE[2008-01-14],USER[Brian]]],ACTION_20080114230639[MODIFY[DESC[Path:.->!],TIME[17:54:17],DATE[2008-01-14],USER[Brian]]],ACTION_20080114230639[MODIFY[DESC[Path:.->!],TIME[18:06:34],DATE[2008-01-14],USER[Brian]]]]],ACL[WRITE[authors],READ[guests]]]
\.


--
-- Data for Name: favorite_books; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY favorite_books (employee_id, books) FROM stdin;
102	{"The Hitchhikers Guide to the Galaxy"}
103	{"The Hobbit","Kitten, Squared"}
102	{"The Hitchhikers Guide to the Galaxy"}
103	{"The Hobbit","Kitten, Squared"}
\.


--
-- Data for Name: lusers; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY lusers (name, lab) FROM stdin;
Brian	Brian
Nik	Nik
Mike	Mike
\.


--
-- Data for Name: page_blocks; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY page_blocks (blockid, pageid, parentblockid, blocktype, text, sibling, current, label) FROM stdin;
25623	805	25623	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828021255((CREATE((DESC(("Demo 4e Access Control in Action")),TIME(("22:12:55")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
21214	781	21214	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825042112((CREATE((DESC(("Demo2aLinks")),TIME(("00:02:04")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825042112((MODIFY((DESC(("Path:.->!")),TIME(("00:17:17")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825042112((MODIFY((DESC(("Path:.->!")),TIME(("00:17:52")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825042112((MODIFY((DESC(("Path:.->!")),TIME(("00:18:51")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825042112((MODIFY((DESC(("Path:.->!")),TIME(("00:19:21")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825042112((MODIFY((DESC(("Path:.->!")),TIME(("00:19:43")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825042112((MODIFY((DESC(("Path:.->!")),TIME(("00:21:04")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
24050	792	24050	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825180818((CREATE((DESC(("Demo3eCopyPaste")),TIME(("14:07:12")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25210	801	25210	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828020505((CREATE((DESC(("Demo 4 Labels")),TIME(("22:05:05")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
19278	765	19278	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070817192703((MODIFY((USER((Brian")),DATE(("2007-08-17")),TIME(("15:27:03)),DESC(("Path:.->!)))))),ACTION_20070817192605((CREATE((USER((Brian")),TIME(("15:26:05)),DESC(("SELinksDemoRestricted")),DATE(("2007-08-17)))))))))),ACL((WRITE((authors)),READ((guests))))))
19287	765	19279	labeled		4	t	SECURITY((PROV((ACTIONS((ACTION_20070817192729((RELABEL((DESC(("ACL{WRITE{administrators};READ{administrators}}")),TIME(("15:27:29")),DATE(("2007-08-17")),USER((Brian)))))))))),ACL((WRITE((administrators)),READ((administrators))))))
19289	765	19279	labeled		2	t	SECURITY((PROV((ACTIONS((ACTION_20070817192746((RELABEL((DESC(("ACL{WRITE{administrators};READ{guests}}")),TIME(("15:27:46")),DATE(("2007-08-17")),USER((Brian)))))))))),ACL((WRITE((administrators)),READ((guests))))))
20326	776	20326	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825034146((CREATE((DESC(("*Start Here*")),TIME(("23:41:46")),DATE(("2007-08-24")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
20793	780	20793	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825035543((CREATE((DESC(("Demo 2 Background")),TIME(("23:55:43")),DATE(("2007-08-24")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
20847	782	20847	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825040815((CREATE((DESC(("Demo 2b SElinks")),TIME(("00:08:15")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
20939	783	20939	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825041619((CREATE((DESC(("Demo2cCPAWiki")),TIME(("00:15:39")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825041619((MODIFY((DESC(("Path:.->!")),TIME(("00:16:16")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
21240	784	21240	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825042348((CREATE((DESC(("Demo 3 Wiki Features")),TIME(("00:23:48")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
22399	788	22399	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825141756((CREATE((DESC(("Demo 3c URLs")),TIME(("10:17:55")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
23689	790	23689	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825144217((CREATE((DESC(("Demo 3d Other Features")),TIME(("10:42:17")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
24052	792	24051	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070825180819((CREATE((DESC(("Demo3eCopyPaste")),TIME(("14:07:12")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825180819((MODIFY((DESC(("Path:.->.0->!")),TIME(("14:07:50")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
24066	792	24051	labeled		2	t	SECURITY((PROV((ACTIONS((ACTION_20070825180819((RELABEL((DESC(("ACL{WRITE{guests;authors};READ{guests}}")),TIME(("14:07:26")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((guests,authors)),READ((guests))))))
24070	792	24051	labeled		4	t	SECURITY((PROV((ACTIONS((ACTION_20070825180819((CREATE((DESC(("Demo3eCopyPaste")),TIME(("14:07:12")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070825180819((MODIFY((DESC(("Path:.->.4->!")),TIME(("14:08:14")),DATE(("2007-08-25")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
23902	790	23691	word	\n	68	t	(())
23903	790	23691	formatted		69	t	(())
23904	790	23903	word	Escaping Text	0	t	(())
24542	786	24542	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070827233726((CREATE((DESC(("Demo3aTextEditing")),TIME(("09:55:28")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070827233726((MODIFY((DESC(("Path:.->!")),TIME(("19:37:21")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25055	787	25055	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070827233915((CREATE((DESC(("Demo3bTextFormatting")),TIME(("10:04:21")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070827233915((MODIFY((DESC(("Path:.->!")),TIME(("10:05:11")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070827233915((MODIFY((DESC(("Path:.->!")),TIME(("10:06:29")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070827233915((MODIFY((DESC(("Path:.->!")),TIME(("10:07:01")),DATE(("2007-08-25")),USER((Brian)))))),ACTION_20070827233915((MODIFY((DESC(("Path:.->!")),TIME(("19:38:03")),DATE(("2007-08-27")),USER((Brian)))))),ACTION_20070827233915((MODIFY((DESC(("Path:.->!")),TIME(("19:39:03")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25453	802	25453	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828020627((CREATE((DESC(("Demo4aCreatingaPageRevisited")),TIME(("22:06:03")),DATE(("2007-08-27")),USER((Brian)))))),ACTION_20070828020627((MODIFY((DESC(("Path:.->!")),TIME(("22:06:23")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25517	803	25517	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828020743((CREATE((DESC(("Demo 4b Modifying Content Revisted")),TIME(("22:07:43")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25558	804	25558	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828021026((CREATE((DESC(("Demo 4c Modifying Access Control")),TIME(("22:10:26")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25756	807	25756	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828021658((CREATE((DESC(("Demo 4d Copy Paste Revisited")),TIME(("22:16:58")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25821	806	25821	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828021749((CREATE((DESC(("Demo6Conclusion")),TIME(("22:13:55")),DATE(("2007-08-27")),USER((Brian)))))),ACTION_20070828021749((MODIFY((DESC(("Path:.->!")),TIME(("22:17:46")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
25852	808	25852	labeled		0	t	SECURITY((PROV((ACTIONS((ACTION_20070828022442((CREATE((DESC(("Demo 1 Overview")),TIME(("22:24:42")),DATE(("2007-08-27")),USER((Brian)))))))))),ACL((WRITE((authors)),READ((guests))))))
23798	790	23691	word	\r	39	t	(())
25130	787	25129	word	 Superscript, Subscript 	0	t	(())
25845	806	25844	word	------	0	t	(())
23744	790	23743	word	\r\n\r\n	0	t	(())
20952	783	20940	formatted		7	t	(())
20953	783	20952	word	\r\n\r\n	0	t	(())
19279	765	19278	compound		0	t	(())
19280	765	19279	word	This page is divided into three sections. This first section is writable by writers,	0	t	(())
19281	765	19279	formatted		1	t	(())
19282	765	19281	word	\r\n\r\n	0	t	(())
19284	765	19279	formatted		3	t	(())
19285	765	19284	word	\r\n\r\n	0	t	(())
19288	765	19287	word	the third section is only readable and writable by administrators.	0	t	(())
19290	765	19289	word	the second section is readable by readers, but writable only by administrators.	0	t	(())
20328	776	20326	compound		0	t	(())
20329	776	20328	word	Welcome to the 	0	t	(())
20330	776	20328	formatted		1	t	(())
20331	776	20330	word	SEWiki	0	t	(())
20332	776	20328	word	 application.	2	t	(())
20333	776	20328	formatted		3	t	(())
20334	776	20333	word	\r\n\r\n	0	t	(())
20335	776	20328	word	This document serves as a demonstration and tutorial of the SEWiki system, including both the standard Wiki features and the security features. You will be guided through the process of creating and editing a Wiki document. 	4	t	(())
20336	776	20328	formatted		5	t	(())
20337	776	20336	word	\r\n\r\n	0	t	(())
20338	776	20328	word	At this point, you should be logged in as the 	6	t	(())
20339	776	20328	formatted		7	t	(())
20340	776	20339	word	demo	0	t	(())
20341	776	20328	word	 user using the password 	8	t	(())
20342	776	20328	formatted		9	t	(())
20343	776	20342	word	demopw	0	t	(())
20344	776	20328	word	. If not, click 	10	t	(())
20345	776	20328	formatted		11	t	(())
20346	776	20345	word	Main menu	0	t	(())
20347	776	20328	word	, then 	12	t	(())
20348	776	20328	formatted		13	t	(())
20349	776	20348	word	Logout	0	t	(())
20350	776	20328	word	, and log back in using above username and password.	14	t	(())
20351	776	20328	formatted		15	t	(())
20352	776	20351	word	\r\n\r\n	0	t	(())
20353	776	20328	word	At some steps, you will be asked to create and edit a separate page. The easiest way to do this is to use two browser windows; one for viewing the demonstration, and another for creating your own pages. You can open up a second page by right	16	t	(())
20354	776	20328	word	-	17	t	(())
20355	776	20328	word	clicking 	18	t	(())
20356	776	20328	formatted		19	t	(())
20357	776	20356	word	this link	0	t	(())
20358	776	20328	word	, and selecting 	20	t	(())
20359	776	20328	formatted		21	t	(())
20360	776	20359	word	Open link in new window	0	t	(())
20361	776	20328	word	.	22	t	(())
20362	776	20328	formatted		23	t	(())
20363	776	20362	word	\r\n\r\n	0	t	(())
20364	776	20328	word	To begin, continue on to 	24	t	(())
20365	776	20328	formatted		25	t	(())
20366	776	20365	word	Demo 1 Overview	0	t	(())
20367	776	20328	formatted		26	t	(())
20368	776	20367	word	\r\n\r\n	0	t	(())
20795	780	20793	compound		0	t	(())
20796	780	20795	word	This section discusses the background behind the SEWiki application.	0	t	(())
20797	780	20795	formatted		1	t	(())
20798	780	20797	word	\r\n\r\n	0	t	(())
20799	780	20795	word	\r	2	t	(())
20800	780	20795	compound		3	t	(())
20801	780	20800	word	\n	0	t	(())
20802	780	20800	formatted		1	t	(())
20803	780	20802	compound		0	t	(())
20804	780	20803	formatted		0	t	(())
20805	780	20804	formatted		0	t	(())
20806	780	20805	compound		0	t	(())
20807	780	20806	formatted		0	t	(())
20808	780	20807	word	Demo 2a Links	0	t	(())
20809	780	20806	word	\r	1	t	(())
20810	780	20806	word	\n	2	t	(())
20811	780	20803	formatted		1	t	(())
20812	780	20811	formatted		0	t	(())
20813	780	20812	compound		0	t	(())
20814	780	20813	formatted		0	t	(())
20815	780	20814	word	Demo 2b SELinks	0	t	(())
20816	780	20813	word	\r	1	t	(())
20817	780	20813	word	\n	2	t	(())
20818	780	20803	formatted		2	t	(())
20819	780	20818	formatted		0	t	(())
20820	780	20819	compound		0	t	(())
20821	780	20820	formatted		0	t	(())
20822	780	20821	word	Demo 2c SEWiki	0	t	(())
20823	780	20820	word	\r	1	t	(())
20824	780	20820	word	\n	2	t	(())
20825	780	20795	word	\r	4	t	(())
20826	780	20795	word	\n	5	t	(())
20849	782	20847	compound		0	t	(())
20850	782	20849	word	SELinks is a security	0	t	(())
20851	782	20849	word	-	1	t	(())
20852	782	20849	word	enhanced version of Links being developed in conjunction with this Wiki. It is based on a formalism called 	2	t	(())
20853	782	20849	formatted		3	t	(())
20854	782	20853	word	Fable	0	t	(())
20855	782	20849	word	. The main ideas behind the SELinks extensions are to associate 	4	t	(())
20856	782	20849	formatted		5	t	(())
20857	782	20856	word	security labels	0	t	(())
20858	782	20849	word	 with data or actions. The semantics of these labels are then defined via an 	6	t	(())
20859	782	20849	formatted		7	t	(())
20860	782	20859	word	enforcement policy	0	t	(())
20861	782	20849	word	. Labeled terms can only be constructed, deconstructed, and relabeled by means of the enforcement policies. SELinks is able to represent a wide variety of security policies, including access control, information flow, data provenance, trusted declassification, and security automata. 	8	t	(())
20862	782	20849	formatted		9	t	(())
20863	782	20862	word	\r\n\r\n	0	t	(())
20864	782	20849	word	Next: 	10	t	(())
20865	782	20849	formatted		11	t	(())
20866	782	20865	word	Demo 2c CPA Wiki	0	t	(())
20940	783	20939	compound		0	t	(())
20941	783	20940	formatted		0	t	(())
20942	783	20941	word	Features	0	t	(())
20943	783	20940	formatted		1	t	(())
20944	783	20943	word	\r\n\r\n	0	t	(())
20945	783	20940	word	The SEWiki has many standard wiki features, including text	2	t	(())
20946	783	20940	word	-	3	t	(())
20947	783	20940	word	based formatting, and internal and external linking. In addition, it implements access control and data provenance policies.	4	t	(())
20948	783	20940	formatted		5	t	(())
20949	783	20948	word	\r\n\r\n	0	t	(())
20950	783	20940	formatted		6	t	(())
20951	783	20950	word	Implementation	0	t	(())
20954	783	20940	word	The SEWiki is currently implemented as 3,500 lines of Links code. It uses security labels and policies based on those of SELinks; however, these are currently implemented at the user	8	t	(())
20955	783	20940	word	-	9	t	(())
20956	783	20940	word	level, rather than being baked into the language itself. 	10	t	(())
20957	783	20940	formatted		11	t	(())
20958	783	20957	word	\r\n\r\n	0	t	(())
20959	783	20940	word	Wiki documents are composed of 	12	t	(())
20960	783	20940	formatted		13	t	(())
20961	783	20960	word	blocks	0	t	(())
20962	783	20940	word	, which can range from an entire page to a single word. Blocks are also the primary unit for Labeled data; any block can be enclosed by a 	14	t	(())
20963	783	20940	formatted		15	t	(())
20964	783	20963	word	LabeledBlock	0	t	(())
20965	783	20940	word	 consisting of a Label and a block labeled by that label.	16	t	(())
20966	783	20940	formatted		17	t	(())
20967	783	20966	word	\r\n\r\n	0	t	(())
20968	783	20940	word	Work is in progress on getting the SEWiki code to check and run using the full SELinks compiler.	18	t	(())
20969	783	20940	formatted		19	t	(())
20970	783	20969	word	\r\n\r\n	0	t	(())
20971	783	20940	word	Next: 	20	t	(())
20972	783	20940	formatted		21	t	(())
20973	783	20972	word	Demo 3 Wiki Features	0	t	(())
20974	783	20940	word	\r	22	t	(())
20975	783	20940	word	\n	23	t	(())
21215	781	21214	compound		0	t	(())
21216	781	21215	word	Links is a web programming language currently being developed at the 	0	t	(())
21217	781	21215	formatted		1	t	(())
21218	781	21217	word	University of Edinburgh	0	t	(())
21219	781	21215	word	. One of the primary goals of Links is to provide a single language for all three tiers of web programming: web browsing, web serving, and database access. 	2	t	(())
21220	781	21215	formatted		3	t	(())
21221	781	21220	word	\r\n\r\n	0	t	(())
21222	781	21215	word	Links code is compiled into client	4	t	(())
21223	781	21215	word	-	5	t	(())
21224	781	21215	word	side Javascript on the client, server	6	t	(())
21225	781	21215	word	-	7	t	(())
21226	781	21215	word	side code, and database	8	t	(())
21227	781	21215	word	-	9	t	(())
21228	781	21215	word	level SQL code.	10	t	(())
21229	781	21215	formatted		11	t	(())
21230	781	21229	word	\r\n\r\n	0	t	(())
21231	781	21215	word	More details can be found at the 	12	t	(())
21232	781	21215	formatted		13	t	(())
21233	781	21232	word	Links Home Page	0	t	(())
21234	781	21215	word	.	14	t	(())
21235	781	21215	formatted		15	t	(())
21236	781	21235	word	\r\n\r\n	0	t	(())
21237	781	21215	word	Next: 	16	t	(())
21238	781	21215	formatted		17	t	(())
21239	781	21238	word	Demo 2b SElinks	0	t	(())
21242	784	21240	compound		0	t	(())
21243	784	21242	word	Now let us examine the various wiki features.	0	t	(())
21244	784	21242	formatted		1	t	(())
21245	784	21244	word	\r\n\r\n	0	t	(())
21246	784	21242	word	\r	2	t	(())
21247	784	21242	compound		3	t	(())
21248	784	21247	word	\n	0	t	(())
21249	784	21247	formatted		1	t	(())
21250	784	21249	compound		0	t	(())
21251	784	21250	formatted		0	t	(())
21252	784	21251	formatted		0	t	(())
21253	784	21252	compound		0	t	(())
21254	784	21253	formatted		0	t	(())
21255	784	21254	word	Demo 3a TextEditing	0	t	(())
21256	784	21253	word	\r	1	t	(())
21257	784	21253	word	\n	2	t	(())
21258	784	21250	formatted		1	t	(())
21259	784	21258	formatted		0	t	(())
21260	784	21259	compound		0	t	(())
21261	784	21260	formatted		0	t	(())
21262	784	21261	word	Demo 3b Text Formatting	0	t	(())
21263	784	21260	word	\r	1	t	(())
21264	784	21260	word	\n	2	t	(())
21265	784	21250	formatted		2	t	(())
21266	784	21265	formatted		0	t	(())
21267	784	21266	compound		0	t	(())
21268	784	21267	formatted		0	t	(())
21269	784	21268	word	Demo 3c URLs	0	t	(())
21270	784	21267	word	\r	1	t	(())
21271	784	21267	word	\n	2	t	(())
21272	784	21250	formatted		3	t	(())
21273	784	21272	formatted		0	t	(())
21274	784	21273	compound		0	t	(())
21275	784	21274	formatted		0	t	(())
21276	784	21275	word	Demo 3d Other Features	0	t	(())
21277	784	21274	word	\r	1	t	(())
21278	784	21274	word	\n	2	t	(())
21279	784	21250	formatted		4	t	(())
21280	784	21279	formatted		0	t	(())
21281	784	21280	compound		0	t	(())
21282	784	21281	formatted		0	t	(())
21283	784	21282	word	Demo 3e Copy Paste	0	t	(())
21284	784	21281	word	\r	1	t	(())
21285	784	21281	word	\n	2	t	(())
21286	784	21242	formatted		4	t	(())
21287	784	21286	word	\r\n\r\n	0	t	(())
22401	788	22399	compound		0	t	(())
22402	788	22401	word	In most wiki systems, there are two types of hyperlinks:	0	t	(())
22403	788	22401	formatted		1	t	(())
22404	788	22403	word	\r\n\r\n	0	t	(())
22405	788	22401	word	\r	2	t	(())
22406	788	22401	compound		3	t	(())
22407	788	22406	word	\n	0	t	(())
22408	788	22406	formatted		1	t	(())
22409	788	22408	compound		0	t	(())
22410	788	22409	formatted		0	t	(())
22411	788	22410	formatted		0	t	(())
22412	788	22411	compound		0	t	(())
22413	788	22412	word	Internal ((to other pages inside the wiki))	0	t	(())
22414	788	22412	word	\r	1	t	(())
22415	788	22412	word	\n	2	t	(())
22416	788	22409	formatted		1	t	(())
22417	788	22416	formatted		0	t	(())
22418	788	22417	compound		0	t	(())
22419	788	22418	word	External ((to pages outside the wiki))	0	t	(())
22420	788	22418	word	\r	1	t	(())
22421	788	22418	word	\n	2	t	(())
22422	788	22401	formatted		4	t	(())
22423	788	22422	word	\r\n\r\n	0	t	(())
22424	788	22401	word	The SEWiki application supports both types.	5	t	(())
22425	788	22401	formatted		6	t	(())
22426	788	22425	word	\r\n\r\n	0	t	(())
22427	788	22401	formatted		7	t	(())
22428	788	22427	word	Internal Links	0	t	(())
22429	788	22401	formatted		8	t	(())
22430	788	22429	word	\r\n\r\n	0	t	(())
22431	788	22401	word	Internal links link between pages of the wiki. To create one, surround the title of the page you wish to link to in double brackets:	9	t	(())
22432	788	22401	formatted		10	t	(())
22433	788	22432	word	\r\n\r\n	0	t	(())
22434	788	22401	word	\r	11	t	(())
22435	788	22401	compound		12	t	(())
22436	788	22435	word	\n	0	t	(())
22437	788	22435	formatted		1	t	(())
22438	788	22437	compound		0	t	(())
22439	788	22438	word	((((My Test Page))))\r\n	0	t	(())
22440	788	22401	word	\r	13	t	(())
22441	788	22401	word	\n	14	t	(())
22442	788	22401	formatted		15	t	(())
22443	788	22442	word	My Test Page	0	t	(())
22444	788	22401	formatted		16	t	(())
22445	788	22444	word	\r\n\r\n	0	t	(())
22446	788	22401	word	If a page with that title already exists, the link will take you there. If no page with that name exists, clicking on the link will prompt you to create the page.	17	t	(())
22447	788	22401	formatted		18	t	(())
22448	788	22447	word	\r\n\r\n	0	t	(())
22449	788	22401	formatted		19	t	(())
22450	788	22449	word	External Links	0	t	(())
22451	788	22401	formatted		20	t	(())
22452	788	22451	word	\r\n\r\n	0	t	(())
22453	788	22401	word	External links are to any web site on the Internet. They have a slightly more complex syntax:	21	t	(())
22454	788	22401	formatted		22	t	(())
22455	788	22454	word	\r\n\r\n	0	t	(())
22456	788	22401	word	\r	23	t	(())
22457	788	22401	compound		24	t	(())
22458	788	22457	word	\n	0	t	(())
22459	788	22457	formatted		1	t	(())
22460	788	22459	compound		0	t	(())
22461	788	22460	word	((Google)) ((http://www.google.com/))\r\n	0	t	(())
22462	788	22401	word	\r	25	t	(())
22463	788	22401	word	\n	26	t	(())
22464	788	22401	formatted		27	t	(())
22465	788	22464	word	Google	0	t	(())
22466	788	22401	formatted		28	t	(())
22467	788	22466	word	\r\n\r\n	0	t	(())
22468	788	22401	word	Note that any protocol that your web browser supports can be used ((e.g., https, mailto)):	29	t	(())
22469	788	22401	formatted		30	t	(())
22470	788	22469	word	\r\n\r\n	0	t	(())
22471	788	22401	word	\r	31	t	(())
22472	788	22401	compound		32	t	(())
22473	788	22472	word	\n	0	t	(())
22474	788	22472	formatted		1	t	(())
22475	788	22474	compound		0	t	(())
22476	788	22475	word	((Bank of America)) ((https://www.bankofamerica.com/))\r\n	0	t	(())
22477	788	22475	word	((My email)) ((mailto:bjc@cs.umd.edu))\r\n	1	t	(())
22478	788	22401	word	\r	33	t	(())
22479	788	22401	word	\n	34	t	(())
22480	788	22401	formatted		35	t	(())
22481	788	22480	word	Bank of America	0	t	(())
22482	788	22401	formatted		36	t	(())
22483	788	22482	word	\r\n\r\n	0	t	(())
22484	788	22401	formatted		37	t	(())
22485	788	22484	word	My email	0	t	(())
22486	788	22401	formatted		38	t	(())
22487	788	22486	word	\r\n\r\n	0	t	(())
22488	788	22401	formatted		39	t	(())
22489	788	22488	word	------	0	t	(())
22490	788	22401	formatted		40	t	(())
22491	788	22490	word	\r\n\r\n	0	t	(())
22492	788	22401	word	Let's continue to examine other Wiki features in 	41	t	(())
22493	788	22401	formatted		42	t	(())
22494	788	22493	word	Demo 3d Other Features	0	t	(())
22495	788	22401	word	.	43	t	(())
22496	788	22401	formatted		44	t	(())
22497	788	22496	word	\r\n\r\n	0	t	(())
23691	790	23689	compound		0	t	(())
23692	790	23691	word	In this section we examine a few more advanced features that didn't fit into the previous sections:	0	t	(())
23693	790	23691	formatted		1	t	(())
23694	790	23693	word	\r\n\r\n	0	t	(())
23695	790	23691	word	\r	2	t	(())
23696	790	23691	compound		3	t	(())
23697	790	23696	word	\n	0	t	(())
23698	790	23696	formatted		1	t	(())
23699	790	23698	compound		0	t	(())
23700	790	23699	formatted		0	t	(())
23701	790	23700	formatted		0	t	(())
23702	790	23701	compound		0	t	(())
23703	790	23702	word	Images	0	t	(())
23704	790	23702	word	\r	1	t	(())
23705	790	23702	word	\n	2	t	(())
23706	790	23699	formatted		1	t	(())
23707	790	23706	formatted		0	t	(())
23708	790	23707	compound		0	t	(())
23709	790	23708	word	Lists	0	t	(())
23710	790	23708	word	\r	1	t	(())
23711	790	23708	word	\n	2	t	(())
23712	790	23699	formatted		2	t	(())
23713	790	23712	formatted		0	t	(())
23714	790	23713	compound		0	t	(())
23715	790	23714	word	Horizontal lines	0	t	(())
23716	790	23714	word	\r	1	t	(())
23717	790	23714	word	\n	2	t	(())
23718	790	23699	formatted		3	t	(())
23719	790	23718	formatted		0	t	(())
23720	790	23719	compound		0	t	(())
23721	790	23720	word	Escaping text	0	t	(())
23722	790	23720	word	\r	1	t	(())
23723	790	23720	word	\n	2	t	(())
23724	790	23691	word	\r	4	t	(())
23725	790	23691	word	\n	5	t	(())
23726	790	23691	formatted		6	t	(())
23727	790	23726	word	Images	0	t	(())
23728	790	23691	formatted		7	t	(())
23729	790	23728	word	\r\n\r\n	0	t	(())
23730	790	23691	word	Images are specified similarly to external hyperlinks, but with a prepended exclamation mark:	8	t	(())
23731	790	23691	formatted		9	t	(())
23732	790	23731	word	\r\n\r\n	0	t	(())
23733	790	23691	word	\r	10	t	(())
23734	790	23691	compound		11	t	(())
23735	790	23734	word	\n	0	t	(())
23736	790	23734	formatted		1	t	(())
23737	790	23736	compound		0	t	(())
23738	790	23737	word	!((alternative text)) ((http://www.cs.umd.edu/assets/images/logos/globe2.gif))\r\n	0	t	(())
23739	790	23691	word	\r	12	t	(())
23740	790	23691	word	\n	13	t	(())
23741	790	23691	formatted		14	t	(())
23742	790	23741	word	alternative text	0	t	(())
23743	790	23691	formatted		15	t	(())
23745	790	23691	word	Here, 	16	t	(())
23746	790	23691	formatted		17	t	(())
23747	790	23746	word	alternative text	0	t	(())
23748	790	23691	word	 is the text that is displayed when a user accesses the page with a browser that cannot display images ((e.g., text	18	t	(())
23749	790	23691	word	-	19	t	(())
23750	790	23691	word	 or speech	20	t	(())
23751	790	23691	word	-	21	t	(())
23752	790	23691	word	based)). The rest of the formatting is the web address of the image.	22	t	(())
23753	790	23691	formatted		23	t	(())
23754	790	23753	word	\r\n\r\n	0	t	(())
23755	790	23691	formatted		24	t	(())
23756	790	23755	word	Lists	0	t	(())
23757	790	23691	formatted		25	t	(())
23758	790	23757	word	\r\n\r\n	0	t	(())
23759	790	23691	formatted		26	t	(())
23760	790	23759	word	Note:	0	t	(())
23761	790	23691	word	 Lists are a bit finicky at this point. It's possible to create them and restore them, but modification doesn't always work.	27	t	(())
23762	790	23691	formatted		28	t	(())
23763	790	23762	word	\r\n\r\n	0	t	(())
23765	790	23691	formatted		30	t	(())
23766	790	23765	word	\r\n\r\n	0	t	(())
23767	790	23691	word	To create a list, you currently must leave two blank lines, then use one of the following syntaxes:	31	t	(())
23768	790	23691	formatted		32	t	(())
23769	790	23768	word	\r\n\r\n	0	t	(())
23770	790	23691	word	\r	33	t	(())
23771	790	23691	compound		34	t	(())
23772	790	23771	word	\n	0	t	(())
23773	790	23771	formatted		1	t	(())
23774	790	23773	compound		0	t	(())
23775	790	23774	word	* Bulleted Item 1\r\n	0	t	(())
23776	790	23774	word	* Bulleted Item 2\r\n	1	t	(())
23777	790	23691	formatted		35	t	(())
23778	790	23777	word	\r\n\r\n	0	t	(())
23779	790	23691	word	\r	36	t	(())
23780	790	23691	compound		37	t	(())
23781	790	23780	word	\n	0	t	(())
23782	790	23780	formatted		1	t	(())
23783	790	23782	compound		0	t	(())
23784	790	23783	formatted		0	t	(())
23785	790	23784	formatted		0	t	(())
23786	790	23785	compound		0	t	(())
23787	790	23786	word	Bulleted Item 1	0	t	(())
23788	790	23786	word	\r	1	t	(())
23789	790	23786	word	\n	2	t	(())
23790	790	23783	formatted		1	t	(())
23791	790	23790	formatted		0	t	(())
23792	790	23791	compound		0	t	(())
23793	790	23792	word	Bulleted Item 2	0	t	(())
23794	790	23792	word	\r	1	t	(())
23795	790	23792	word	\n	2	t	(())
23796	790	23691	formatted		38	t	(())
23797	790	23796	word	\r\n\r\n	0	t	(())
23799	790	23691	compound		40	t	(())
23800	790	23799	word	\n	0	t	(())
23801	790	23799	formatted		1	t	(())
23802	790	23801	compound		0	t	(())
23803	790	23802	word	1. Numbered Item 1\r\n	0	t	(())
23804	790	23802	word	2. Numbered Item 2\r\n	1	t	(())
23805	790	23691	formatted		41	t	(())
23806	790	23805	word	\r\n\r\n	0	t	(())
23807	790	23691	word	\r	42	t	(())
23808	790	23691	compound		43	t	(())
23809	790	23808	word	\n	0	t	(())
23810	790	23808	formatted		1	t	(())
23811	790	23810	compound		0	t	(())
23812	790	23811	formatted		0	t	(())
23813	790	23812	formatted		0	t	(())
23814	790	23813	compound		0	t	(())
23815	790	23814	word	Numbered Item 1	0	t	(())
23816	790	23814	word	\r	1	t	(())
23817	790	23814	word	\n	2	t	(())
23818	790	23811	formatted		1	t	(())
23819	790	23818	formatted		0	t	(())
23820	790	23819	compound		0	t	(())
23821	790	23820	word	Numbered Item 2	0	t	(())
23822	790	23820	word	\r	1	t	(())
23823	790	23820	word	\n	2	t	(())
23824	790	23691	formatted		44	t	(())
23825	790	23824	word	\r\n\r\n	0	t	(())
23826	790	23691	word	\r	45	t	(())
23827	790	23691	word	\n	46	t	(())
23828	790	23691	word	To make a multiple	47	t	(())
23829	790	23691	word	-	48	t	(())
23830	790	23691	word	level list, indent by 4 spaces:	49	t	(())
23831	790	23691	formatted		50	t	(())
23832	790	23831	word	\r\n\r\n	0	t	(())
23833	790	23691	word	\r	51	t	(())
23834	790	23691	compound		52	t	(())
23835	790	23834	word	\n	0	t	(())
23836	790	23834	formatted		1	t	(())
23837	790	23836	compound		0	t	(())
23838	790	23837	word	1. Item 1\r\n	0	t	(())
23839	790	23837	word	    * Sub Item\r\n	1	t	(())
23840	790	23837	word	    * Sub Item\r\n	2	t	(())
23841	790	23837	word	2. Item 2\r\n	3	t	(())
23842	790	23837	word	3. Item 3\r\n	4	t	(())
23843	790	23691	formatted		53	t	(())
23844	790	23843	word	\r\n\r\n	0	t	(())
23845	790	23691	word	\r	54	t	(())
23846	790	23691	compound		55	t	(())
23847	790	23846	word	\n	0	t	(())
23848	790	23846	formatted		1	t	(())
23849	790	23848	compound		0	t	(())
23850	790	23849	formatted		0	t	(())
23851	790	23850	formatted		0	t	(())
23852	790	23851	compound		0	t	(())
23853	790	23852	word	Item 1	0	t	(())
23854	790	23852	word	\r	1	t	(())
23855	790	23852	word	\n	2	t	(())
23856	790	23849	formatted		1	t	(())
23857	790	23856	formatted		0	t	(())
23858	790	23857	compound		0	t	(())
23859	790	23858	word	Sub Item	0	t	(())
23860	790	23858	word	\r	1	t	(())
23861	790	23858	word	\n	2	t	(())
23862	790	23849	formatted		2	t	(())
23863	790	23862	formatted		0	t	(())
23864	790	23863	compound		0	t	(())
23865	790	23864	word	Sub Item	0	t	(())
23866	790	23864	word	\r	1	t	(())
23867	790	23864	word	\n	2	t	(())
23868	790	23849	formatted		3	t	(())
23869	790	23868	formatted		0	t	(())
23870	790	23869	compound		0	t	(())
23871	790	23870	word	Item 2	0	t	(())
23872	790	23870	word	\r	1	t	(())
23873	790	23870	word	\n	2	t	(())
23874	790	23849	formatted		4	t	(())
23875	790	23874	formatted		0	t	(())
23876	790	23875	compound		0	t	(())
23877	790	23876	word	Item 3	0	t	(())
23878	790	23876	word	\r	1	t	(())
23879	790	23876	word	\n	2	t	(())
23880	790	23691	formatted		56	t	(())
23881	790	23880	word	\r\n\r\n	0	t	(())
23882	790	23691	formatted		57	t	(())
23883	790	23882	word	Horizontal Lines	0	t	(())
23884	790	23691	formatted		58	t	(())
23885	790	23884	word	\r\n\r\n	0	t	(())
23886	790	23691	word	You can form a horizontal line by typing six hyphens in a row:	59	t	(())
23887	790	23691	formatted		60	t	(())
23888	790	23887	word	\r\n\r\n	0	t	(())
23889	790	23691	word	\r	61	t	(())
23890	790	23691	compound		62	t	(())
23891	790	23890	word	\n	0	t	(())
23892	790	23890	formatted		1	t	(())
23893	790	23892	compound		0	t	(())
23894	790	23893	word	------\r\n	0	t	(())
23895	790	23691	word	\r	63	t	(())
23896	790	23691	word	\n	64	t	(())
23897	790	23691	formatted		65	t	(())
23898	790	23897	word	------	0	t	(())
23899	790	23691	formatted		66	t	(())
23900	790	23899	word	\r\n\r\n	0	t	(())
23901	790	23691	word	\r	67	t	(())
23905	790	23691	formatted		70	t	(())
23906	790	23905	word	\r\n\r\n	0	t	(())
23907	790	23691	word	In order to format all of the previous example, we took advantage of a feature to 	71	t	(())
23908	790	23691	formatted		72	t	(())
23909	790	23908	word	escape	0	t	(())
23910	790	23691	word	 the formatting code, so it appears as normal text. To do this, you must first leave two blank lines, then use the greater	73	t	(())
23911	790	23691	word	-	74	t	(())
23912	790	23691	word	than character:	75	t	(())
23913	790	23691	formatted		76	t	(())
23914	790	23913	word	\r\n\r\n	0	t	(())
23915	790	23691	word	\r	77	t	(())
23916	790	23691	compound		78	t	(())
23917	790	23916	word	\n	0	t	(())
23918	790	23916	formatted		1	t	(())
23919	790	23918	compound		0	t	(())
23920	790	23919	word	>*not italicized*\r\n	0	t	(())
23921	790	23691	formatted		79	t	(())
23922	790	23921	word	\r\n\r\n	0	t	(())
23923	790	23691	word	\r	80	t	(())
23924	790	23691	compound		81	t	(())
23925	790	23924	word	\n	0	t	(())
23926	790	23924	formatted		1	t	(())
23927	790	23926	compound		0	t	(())
23928	790	23927	word	*not italicized*\r\n	0	t	(())
23929	790	23691	word	\r	82	t	(())
23930	790	23691	word	\n	83	t	(())
23931	790	23691	formatted		84	t	(())
23932	790	23931	word	------	0	t	(())
23933	790	23691	formatted		85	t	(())
23934	790	23933	word	\r\n\r\n	0	t	(())
23935	790	23691	word	We discuss a final, non	86	t	(())
23936	790	23691	word	-	87	t	(())
23937	790	23691	word	standard, feature of SEWiki in 	88	t	(())
23938	790	23691	formatted		89	t	(())
23939	790	23938	word	Demo 3e Copy Paste	0	t	(())
23940	790	23691	word	.	90	t	(())
24051	792	24050	compound		0	t	(())
24053	792	24052	compound		0	t	(())
24054	792	24053	word	One novel feature of the SEWiki is the ability to copy and paste blocks from one document to another. To try this, click 	0	t	(())
24055	792	24053	formatted		1	t	(())
24056	792	24055	word	Modify Page	0	t	(())
24057	792	24053	word	 on this page.	2	t	(())
24058	792	24053	formatted		3	t	(())
24059	792	24058	word	\r\n\r\n	0	t	(())
24060	792	24053	word	Next, click 	4	t	(())
24061	792	24053	formatted		5	t	(())
24062	792	24061	word	Copy	0	t	(())
24063	792	24053	word	 next to the labeled block below:	6	t	(())
24064	792	24051	formatted		1	t	(())
24065	792	24064	word	\r\n\r\n	0	t	(())
24067	792	24066	word	This test block demonstrates the copy/paste functionality of the SEWiki.	0	t	(())
24068	792	24051	formatted		3	t	(())
24069	792	24068	word	\r\n\r\n	0	t	(())
24071	792	24070	compound		0	t	(())
24072	792	24071	word	On the page your created ((	0	t	(())
24073	792	24071	formatted		1	t	(())
24074	792	24073	word	My Test Page	0	t	(())
24075	792	24071	word	)), click 	2	t	(())
24076	792	24071	formatted		3	t	(())
24077	792	24076	word	Paste	0	t	(())
24078	792	24071	word	. The page should be pasted below the text you created.	4	t	(())
24079	792	24071	formatted		5	t	(())
24080	792	24079	word	\r\n\r\n	0	t	(())
24081	792	24071	formatted		6	t	(())
24082	792	24081	word	------	0	t	(())
24083	792	24071	formatted		7	t	(())
24084	792	24083	word	\r\n\r\n	0	t	(())
24085	792	24071	word	We have demonstrated all the basic wiki features. Continue to 	8	t	(())
24086	792	24071	formatted		9	t	(())
24087	792	24086	word	Demo 4 Access Control	0	t	(())
24088	792	24071	word	 to begin learning about the security features of the SEWiki.	10	t	(())
24543	786	24542	compound		0	t	(())
24544	786	24543	formatted		0	t	(())
24545	786	24544	word	Page Creation and Text Editing	0	t	(())
24546	786	24543	formatted		1	t	(())
24547	786	24546	word	\r\n\r\n	0	t	(())
24548	786	24543	word	Similar to most wiki applications, SEWiki allows you to create and edit text using a web browser. 	2	t	(())
24549	786	24543	formatted		3	t	(())
24550	786	24549	word	\r\n\r\n	0	t	(())
24551	786	24543	word	If you have not yet done so, 	4	t	(())
24552	786	24543	formatted		5	t	(())
24553	786	24552	word	open	0	t	(())
24554	786	24543	word	 a second copy of this site, log in again as 	6	t	(())
24555	786	24543	formatted		7	t	(())
24556	786	24555	word	demo	0	t	(())
24557	786	24543	word	, ((password: 	8	t	(())
24558	786	24543	formatted		9	t	(())
24559	786	24558	word	demopw	0	t	(())
24560	786	24543	word	)). 	10	t	(())
24561	786	24543	formatted		11	t	(())
24562	786	24561	word	\r\n\r\n	0	t	(())
24563	786	24543	formatted		12	t	(())
24564	786	24563	word	Creating a New Page	0	t	(())
24565	786	24543	formatted		13	t	(())
24566	786	24565	word	\r\n\r\n	0	t	(())
24567	786	24543	word	To create a new page, click 	14	t	(())
24568	786	24543	formatted		15	t	(())
24569	786	24568	word	Create New Page	0	t	(())
24570	786	24543	word	. You will prompted to enter a title and the body of the text. Use 	16	t	(())
24571	786	24543	formatted		17	t	(())
24572	786	24571	word	My Test Page	0	t	(())
24573	786	24543	word	 for the title, enter some plain text ((avoid symbols for now)) for the body, and click 	18	t	(())
24574	786	24543	formatted		19	t	(())
24575	786	24574	word	Save Page	0	t	(())
24576	786	24543	word	.	20	t	(())
24577	786	24543	formatted		21	t	(())
24578	786	24577	word	\r\n\r\n	0	t	(())
24579	786	24543	word	Your page, which has been saved to the database, is now displayed.	22	t	(())
24580	786	24543	formatted		23	t	(())
24581	786	24580	word	\r\n\r\n	0	t	(())
24582	786	24543	formatted		24	t	(())
24583	786	24582	word	 Editing Text 	0	t	(())
24584	786	24543	formatted		25	t	(())
24585	786	24584	word	\r\n\r\n	0	t	(())
24586	786	24543	word	Editing a page is similar. Click 	26	t	(())
24587	786	24543	formatted		27	t	(())
24588	786	24587	word	Modify page	0	t	(())
24589	786	24543	word	 from the options at the bottom of the page. On the next page, you will see a block containing your text; choose 	28	t	(())
24590	786	24543	formatted		29	t	(())
24591	786	24590	word	Edit	0	t	(())
24592	786	24543	word	. 	30	t	(())
24593	786	24543	formatted		31	t	(())
24594	786	24593	word	\r\n\r\n	0	t	(())
24595	786	24543	word	Modify your text, still avoiding symbols, and click 	32	t	(())
24596	786	24543	formatted		33	t	(())
24597	786	24596	word	Save WikiEdit	0	t	(())
24598	786	24543	word	. You will be returned to the editing screen, where you should see your updated page.	34	t	(())
24599	786	24543	formatted		35	t	(())
24600	786	24599	word	\r\n\r\n	0	t	(())
24601	786	24543	word	To learn how to enter formatted text, continue to 	36	t	(())
24602	786	24543	formatted		37	t	(())
24603	786	24602	word	Demo 3b Text Formatting	0	t	(())
24604	786	24543	word	.	38	t	(())
25056	787	25055	compound		0	t	(())
25057	787	25056	word	The SEWiki application allows a wide variety of text	0	t	(())
25058	787	25056	word	-	1	t	(())
25059	787	25056	word	based formatting commands. 	2	t	(())
25060	787	25056	word	\r	3	t	(())
25061	787	25056	word	\n	4	t	(())
25062	787	25056	word	Most formatting is done by surrounding text with a pair of matching symbols.	5	t	(())
25063	787	25056	formatted		6	t	(())
25064	787	25063	word	\r\n\r\n	0	t	(())
25065	787	25056	formatted		7	t	(())
25066	787	25065	word	Examples	0	t	(())
25067	787	25056	formatted		8	t	(())
25068	787	25067	word	\r\n\r\n	0	t	(())
25069	787	25056	formatted		9	t	(())
25070	787	25069	word	 Emphasis 	0	t	(())
25071	787	25056	formatted		10	t	(())
25072	787	25071	word	\r\n\r\n	0	t	(())
25073	787	25056	word	There are two different ways to emphasize ((usually, italicize)) text:	11	t	(())
25074	787	25056	formatted		12	t	(())
25075	787	25074	word	\r\n\r\n	0	t	(())
25076	787	25056	word	\r	13	t	(())
25077	787	25056	compound		14	t	(())
25078	787	25077	word	\n	0	t	(())
25079	787	25077	formatted		1	t	(())
25080	787	25079	compound		0	t	(())
25081	787	25080	word	*emphasis* or _emphasis_\r\n	0	t	(())
25082	787	25056	word	\r	15	t	(())
25083	787	25056	word	\n	16	t	(())
25084	787	25056	formatted		17	t	(())
25085	787	25084	word	emphasis	0	t	(())
25086	787	25056	word	 or 	18	t	(())
25087	787	25056	formatted		19	t	(())
25088	787	25087	word	emphasis	0	t	(())
25089	787	25056	formatted		20	t	(())
25090	787	25089	word	\r\n\r\n	0	t	(())
25091	787	25056	formatted		21	t	(())
25092	787	25091	word	 Bold 	0	t	(())
25093	787	25056	formatted		22	t	(())
25094	787	25093	word	\r\n\r\n	0	t	(())
25095	787	25056	word	Similarly, bold uses two asterisks:	23	t	(())
25096	787	25056	formatted		24	t	(())
25097	787	25096	word	\r\n\r\n	0	t	(())
25098	787	25056	word	\r	25	t	(())
25099	787	25056	compound		26	t	(())
25100	787	25099	word	\n	0	t	(())
25101	787	25099	formatted		1	t	(())
25102	787	25101	compound		0	t	(())
25103	787	25102	word	**bold**\r\n	0	t	(())
25104	787	25056	word	\r	27	t	(())
25105	787	25056	word	\n	28	t	(())
25106	787	25056	formatted		29	t	(())
25107	787	25106	word	bold	0	t	(())
25108	787	25056	formatted		30	t	(())
25109	787	25108	word	\r\n\r\n	0	t	(())
25110	787	25056	formatted		31	t	(())
25111	787	25110	word	Strikethrough	0	t	(())
25112	787	25056	formatted		32	t	(())
25113	787	25112	word	\r\n\r\n	0	t	(())
25114	787	25056	word	To strike out a word, use dashes:	33	t	(())
25115	787	25056	formatted		34	t	(())
25116	787	25115	word	\r\n\r\n	0	t	(())
25117	787	25056	word	\r	35	t	(())
25118	787	25056	compound		36	t	(())
25119	787	25118	word	\n	0	t	(())
25120	787	25118	formatted		1	t	(())
25121	787	25120	compound		0	t	(())
25122	787	25121	word	 --strikethrough--\r\n	0	t	(())
25123	787	25056	word	\r	37	t	(())
25124	787	25056	word	\n	38	t	(())
25125	787	25056	formatted		39	t	(())
25126	787	25125	word	strikethrough	0	t	(())
25127	787	25056	formatted		40	t	(())
25128	787	25127	word	\r\n\r\n	0	t	(())
25129	787	25056	formatted		41	t	(())
25131	787	25056	formatted		42	t	(())
25132	787	25131	word	\r\n\r\n	0	t	(())
25133	787	25056	word	SEWiki supports both superscript and subscript:	43	t	(())
25134	787	25056	formatted		44	t	(())
25135	787	25134	word	\r\n\r\n	0	t	(())
25136	787	25056	word	\r	45	t	(())
25137	787	25056	compound		46	t	(())
25138	787	25137	word	\n	0	t	(())
25139	787	25137	formatted		1	t	(())
25140	787	25139	compound		0	t	(())
25141	787	25140	word	^superscript^normal~subscript~\r\n	0	t	(())
25142	787	25056	word	\r	47	t	(())
25143	787	25056	word	\n	48	t	(())
25144	787	25056	formatted		49	t	(())
25145	787	25144	word	superscript	0	t	(())
25146	787	25056	word	normal	50	t	(())
25147	787	25056	formatted		51	t	(())
25148	787	25147	word	subscript	0	t	(())
25149	787	25056	formatted		52	t	(())
25150	787	25149	word	\r\n\r\n	0	t	(())
25151	787	25056	formatted		53	t	(())
25152	787	25151	word	 Headers 	0	t	(())
25153	787	25056	formatted		54	t	(())
25154	787	25153	word	\r\n\r\n	0	t	(())
25155	787	25056	word	Finally, SEWiki supports two weights of headers:	55	t	(())
25156	787	25056	formatted		56	t	(())
25157	787	25156	word	\r\n\r\n	0	t	(())
25158	787	25056	word	\r	57	t	(())
25159	787	25056	compound		58	t	(())
25160	787	25159	word	\n	0	t	(())
25161	787	25159	formatted		1	t	(())
25162	787	25161	compound		0	t	(())
25163	787	25162	word	 #header1#\r\n	0	t	(())
25164	787	25056	word	\r	59	t	(())
25165	787	25056	word	\n	60	t	(())
25166	787	25056	formatted		61	t	(())
25167	787	25166	word	header1	0	t	(())
25168	787	25056	formatted		62	t	(())
25169	787	25168	word	\r\n\r\n	0	t	(())
25170	787	25056	word	\r	63	t	(())
25171	787	25056	compound		64	t	(())
25172	787	25171	word	\n	0	t	(())
25173	787	25171	formatted		1	t	(())
25174	787	25173	compound		0	t	(())
25175	787	25174	word	 ##header2##\r\n	0	t	(())
25176	787	25056	word	\r	65	t	(())
25177	787	25056	word	\n	66	t	(())
25178	787	25056	formatted		67	t	(())
25179	787	25178	word	header2	0	t	(())
25180	787	25056	formatted		68	t	(())
25181	787	25180	word	\r\n\r\n	0	t	(())
25182	787	25056	formatted		69	t	(())
25183	787	25182	compound		0	t	(())
25184	787	25183	word	Try it	0	t	(())
25185	787	25183	word	!	1	t	(())
25186	787	25056	formatted		70	t	(())
25187	787	25186	word	\r\n\r\n	0	t	(())
25188	787	25056	word	Edit your page again by clicking 	71	t	(())
25189	787	25056	formatted		72	t	(())
25190	787	25189	word	Edit	0	t	(())
25191	787	25056	word	, and try out some of the above formatting.Once you're done, remember to click 	73	t	(())
25192	787	25056	formatted		74	t	(())
25193	787	25192	word	Save WikiEdit	0	t	(())
25194	787	25056	word	.	75	t	(())
25195	787	25056	formatted		76	t	(())
25196	787	25195	word	\r\n\r\n	0	t	(())
25197	787	25056	word	Continue on to 	77	t	(())
25198	787	25056	formatted		78	t	(())
25199	787	25198	word	Demo 3c URLs	0	t	(())
25200	787	25056	word	 to learn how to make hyperlinks. 	79	t	(())
25201	787	25056	formatted		80	t	(())
25202	787	25201	word	\r\n\r\n	0	t	(())
25203	787	25056	formatted		81	t	(())
25204	787	25203	word	\r\n\r\n	0	t	(())
23764	790	23691	word	SEWiki supports many different types of lists: both numbered and bulleted, and different levels of depth.	29	t	(())
25212	801	25210	compound		0	t	(())
25213	801	25212	word	The SEWiki currently supports two types of labels:	0	t	(())
25214	801	25212	formatted		1	t	(())
25215	801	25214	word	\r\n\r\n	0	t	(())
25216	801	25212	word	\r	2	t	(())
25217	801	25212	compound		3	t	(())
25218	801	25217	word	\n	0	t	(())
25219	801	25217	formatted		1	t	(())
25220	801	25219	compound		0	t	(())
25221	801	25220	formatted		0	t	(())
25222	801	25221	formatted		0	t	(())
25223	801	25222	compound		0	t	(())
25224	801	25223	word	access control ((ACL))	0	t	(())
25225	801	25223	word	\r	1	t	(())
25226	801	25223	word	\n	2	t	(())
25227	801	25220	formatted		1	t	(())
25228	801	25227	formatted		0	t	(())
25229	801	25228	compound		0	t	(())
25230	801	25229	word	data provenance ((PROV))	0	t	(())
25231	801	25229	word	\r	1	t	(())
25232	801	25229	word	\n	2	t	(())
25233	801	25212	word	\r	4	t	(())
25234	801	25212	word	\n	5	t	(())
25235	801	25212	word	In the next few sections, we detail the format of these labels, and describe how to view, modify, and interact with them.	6	t	(())
25236	801	25212	formatted		7	t	(())
25237	801	25236	word	\r\n\r\n	0	t	(())
25238	801	25212	formatted		8	t	(())
25239	801	25238	word	Access Control Labels	0	t	(())
25240	801	25212	formatted		9	t	(())
25241	801	25240	word	\r\n\r\n	0	t	(())
25242	801	25212	word	Access control labels are used to enforce who and how data can be viewed and modified. In the case of the SEWiki, data refers to particular blocks on a page. Currently, access control is group	10	t	(())
25243	801	25212	word	-	11	t	(())
25244	801	25212	word	based, where a group is a list of users. Access control labels begin with the string 	12	t	(())
25245	801	25212	formatted		13	t	(())
25246	801	25245	word	ACL	0	t	(())
25247	801	25212	word	, and contain a list of groups with 	14	t	(())
25248	801	25212	formatted		15	t	(())
25249	801	25248	word	read	0	t	(())
25250	801	25212	word	 access, and as list of groups with 	16	t	(())
25251	801	25212	formatted		17	t	(())
25252	801	25251	word	write	0	t	(())
25253	801	25212	word	 access. A sample access control label representation is:	18	t	(())
25254	801	25212	formatted		19	t	(())
25255	801	25254	word	\r\n\r\n	0	t	(())
25256	801	25212	word	\r	20	t	(())
25257	801	25212	compound		21	t	(())
25258	801	25257	word	\n	0	t	(())
25259	801	25257	formatted		1	t	(())
25260	801	25259	compound		0	t	(())
25261	801	25260	word	ACL((READ((readers, writers)), WRITE((writers))))\r\n	0	t	(())
25262	801	25212	word	\r	22	t	(())
25263	801	25212	word	\n	23	t	(())
25264	801	25212	word	This label mentions two groups, 	24	t	(())
25265	801	25212	formatted		25	t	(())
25266	801	25265	word	readers	0	t	(())
25267	801	25212	word	 and 	26	t	(())
25268	801	25212	formatted		27	t	(())
25269	801	25268	word	writers	0	t	(())
25270	801	25212	word	. It grants 	28	t	(())
25271	801	25212	formatted		29	t	(())
25272	801	25271	word	READ	0	t	(())
25273	801	25212	word	 access to both the 	30	t	(())
25274	801	25212	formatted		31	t	(())
25275	801	25274	word	readers	0	t	(())
25276	801	25212	word	 and 	32	t	(())
25277	801	25212	formatted		33	t	(())
25278	801	25277	word	writers	0	t	(())
25279	801	25212	word	 groups, and 	34	t	(())
25280	801	25212	formatted		35	t	(())
25281	801	25280	word	WRITE	0	t	(())
25282	801	25212	word	 access just to the 	36	t	(())
25283	801	25212	formatted		37	t	(())
25284	801	25283	word	writers	0	t	(())
25285	801	25212	word	 group.	38	t	(())
25286	801	25212	formatted		39	t	(())
25287	801	25286	word	\r\n\r\n	0	t	(())
25288	801	25212	formatted		40	t	(())
25289	801	25288	word	Provenance Labels	0	t	(())
25290	801	25212	formatted		41	t	(())
25291	801	25290	word	\r\n\r\n	0	t	(())
25292	801	25212	word	Data provenance labels record all actions to a block, to record when, how, and by whom pages were modified.	42	t	(())
25293	801	25212	formatted		43	t	(())
25294	801	25293	word	\r\n\r\n	0	t	(())
25295	801	25212	word	A provenance label, notated 	44	t	(())
25296	801	25212	formatted		45	t	(())
25297	801	25296	word	PROV	0	t	(())
25298	801	25212	word	, signifies a list of actions which have occured at a particular block. These actions currently include page creation (( CREATEPAGE )), block ((re))labeling (( LABEL )), block modification (( MODIFY )), and block copy/pasting (( PASTE )).	46	t	(())
25299	801	25212	formatted		47	t	(())
25300	801	25299	word	\r\n\r\n	0	t	(())
25301	801	25212	word	Each action in a provenance label includes the operation type, the name of user who performed the action, the date and time the action occurred, and an optional description of the label.	48	t	(())
25302	801	25212	formatted		49	t	(())
25303	801	25302	word	\r\n\r\n	0	t	(())
25304	801	25212	word	Provenance labels look something like:	50	t	(())
25305	801	25212	formatted		51	t	(())
25306	801	25305	word	\r\n\r\n	0	t	(())
25307	801	25212	word	\r	52	t	(())
25308	801	25212	compound		53	t	(())
25309	801	25308	word	\n	0	t	(())
25310	801	25308	formatted		1	t	(())
25311	801	25310	compound		0	t	(())
25312	801	25311	word	PROV.ACTIONS.ACTION_20070825022208.LABEL\r\n	0	t	(())
25313	801	25311	word	....DESC.ACL{WRITE{administrators};READ{readers}}\r\n	1	t	(())
25314	801	25311	word	....TIME.15:27:46\r\n	2	t	(())
25315	801	25311	word	....DATE.2007-08-17\r\n	3	t	(())
25316	801	25311	word	....USER.Brian\r\n	4	t	(())
25317	801	25212	word	\r	54	t	(())
25318	801	25212	word	\n	55	t	(())
25319	801	25212	word	Next: 	56	t	(())
25320	801	25212	formatted		57	t	(())
25321	801	25320	word	Demo 4a Creating a Page Revisited	0	t	(())
25322	801	25212	formatted		58	t	(())
25323	801	25322	word	\r\n\r\n	0	t	(())
25454	802	25453	compound		0	t	(())
25455	802	25454	word	To demonstrate labels in action, we need to create another new page. In your second window, click 	0	t	(())
25456	802	25454	formatted		1	t	(())
25457	802	25456	word	Main menu	0	t	(())
25458	802	25454	word	, then 	2	t	(())
25459	802	25454	formatted		3	t	(())
25460	802	25459	word	Create page	0	t	(())
25461	802	25454	word	. Name your new page 	4	t	(())
25462	802	25454	formatted		5	t	(())
25463	802	25462	word	My Labeled Page	0	t	(())
25464	802	25454	word	 and enter some text. Click 	6	t	(())
25465	802	25454	formatted		7	t	(())
25466	802	25465	word	Save page	0	t	(())
25467	802	25454	word	.	8	t	(())
25468	802	25454	formatted		9	t	(())
25469	802	25468	word	\r\n\r\n	0	t	(())
25470	802	25454	word	Now, click 	10	t	(())
25471	802	25454	formatted		11	t	(())
25472	802	25471	word	View all labels	0	t	(())
25473	802	25454	word	. The 	12	t	(())
25474	802	25454	formatted		13	t	(())
25475	802	25474	word	Page Labels View	0	t	(())
25476	802	25454	word	 displays all the lables for your page in the red, left	14	t	(())
25477	802	25454	word	-	15	t	(())
25478	802	25454	word	hand box. Both 	16	t	(())
25479	802	25454	formatted		17	t	(())
25480	802	25479	word	ACL	0	t	(())
25481	802	25454	word	 and 	18	t	(())
25482	802	25454	formatted		19	t	(())
25483	802	25482	word	PROV	0	t	(())
25484	802	25454	word	 labels are included.	20	t	(())
25485	802	25454	formatted		21	t	(())
25486	802	25485	word	\r\n\r\n	0	t	(())
25487	802	25454	word	The page has an 	22	t	(())
25488	802	25454	formatted		23	t	(())
25489	802	25488	word	ACL	0	t	(())
25490	802	25454	word	 label saying that the page can be viewed by anyone in the 	24	t	(())
25491	802	25454	formatted		25	t	(())
25492	802	25491	word	readers	0	t	(())
25493	802	25454	word	 group, and modified by anyone in the 	26	t	(())
25494	802	25454	formatted		27	t	(())
25495	802	25494	word	writers	0	t	(())
25496	802	25454	word	 group. This is the default access for a new page; the 	28	t	(())
25497	802	25454	formatted		29	t	(())
25498	802	25497	word	demo	0	t	(())
25499	802	25454	word	 user is a member of both of these groups.	30	t	(())
25500	802	25454	formatted		31	t	(())
25501	802	25500	word	\r\n\r\n	0	t	(())
25502	802	25454	word	Furthermore, there is a 	32	t	(())
25503	802	25454	formatted		33	t	(())
25504	802	25503	word	PROV CREATEPAGE	0	t	(())
25505	802	25454	word	 label detailing that the page was created by user 	34	t	(())
25506	802	25454	formatted		35	t	(())
25507	802	25506	word	demo	0	t	(())
25508	802	25454	word	, the time it was created, and the original title of the page.	36	t	(())
25509	802	25454	formatted		37	t	(())
25510	802	25509	word	\r\n\r\n	0	t	(())
25511	802	25454	word	Continue on to 	38	t	(())
25512	802	25454	formatted		39	t	(())
25513	802	25512	word	Demo 4b Modifying Content Revisted	0	t	(())
25514	802	25454	word	 to edit the page.	40	t	(())
25515	802	25454	formatted		41	t	(())
25516	802	25515	word	\r\n\r\n	0	t	(())
25519	803	25517	compound		0	t	(())
25520	803	25519	word	Now let's modify the page. Click 	0	t	(())
25521	803	25519	formatted		1	t	(())
25522	803	25521	word	Modify page	0	t	(())
25523	803	25519	word	 from the options at the bottom. On the next page, choose 	2	t	(())
25524	803	25519	formatted		3	t	(())
25525	803	25524	word	Edit	0	t	(())
25526	803	25519	word	. Change the page in some fashion, and click 	4	t	(())
25527	803	25519	formatted		5	t	(())
25528	803	25527	word	Save WikiEdit	0	t	(())
25529	803	25519	word	. Finally, click 	6	t	(())
25530	803	25519	formatted		7	t	(())
25531	803	25530	word	View all labels	0	t	(())
25532	803	25519	word	.	8	t	(())
25533	803	25519	formatted		9	t	(())
25534	803	25533	word	\r\n\r\n	0	t	(())
25535	803	25519	word	There is now a new 	10	t	(())
25536	803	25519	formatted		11	t	(())
25537	803	25536	word	PROV MODIFYPAGE	0	t	(())
25538	803	25519	word	 entry stating that the page was modified:	12	t	(())
25539	803	25519	formatted		13	t	(())
25540	803	25539	word	\r\n\r\n	0	t	(())
25541	803	25519	word	\r	14	t	(())
25542	803	25519	compound		15	t	(())
25543	803	25542	word	\n	0	t	(())
25544	803	25542	formatted		1	t	(())
25545	803	25544	compound		0	t	(())
25546	803	25545	word	...ACTION_20070817164806.MODIFYPAGE\r\n	0	t	(())
25547	803	25545	word	.....DESC.Path:.->!\r\n	1	t	(())
25548	803	25545	word	.....TIME.12:48:06\r\n	2	t	(())
25549	803	25545	word	.....DATE.2007-08-17\r\n	3	t	(())
25550	803	25545	word	.....USER.demo\r\n	4	t	(())
25551	803	25519	word	\r	16	t	(())
25552	803	25519	word	\n	17	t	(())
25553	803	25519	word	Continue on to 	18	t	(())
25554	803	25519	formatted		19	t	(())
25555	803	25554	word	Demo 4c Modifying Access Control	0	t	(())
25556	803	25519	formatted		20	t	(())
25557	803	25556	word	\r\n\r\n	0	t	(())
25560	804	25558	compound		0	t	(())
25561	804	25560	word	To modify access control, first click 	0	t	(())
25562	804	25560	formatted		1	t	(())
25563	804	25562	word	Edit ACL Labels	0	t	(())
25564	804	25560	word	. You will see that your page consists of a single labeled block. Click 	2	t	(())
25565	804	25560	formatted		3	t	(())
25566	804	25565	word	Edit	0	t	(())
25567	804	25560	word	 in the red box under the Labeled title.	4	t	(())
25568	804	25560	formatted		5	t	(())
25569	804	25568	word	\r\n\r\n	0	t	(())
25570	804	25560	word	Now you will see all of the available labels, and 	6	t	(())
25571	804	25560	formatted		7	t	(())
25572	804	25571	compound		0	t	(())
25573	804	25572	word	READ	0	t	(())
25574	804	25572	word	((	1	t	(())
25575	804	25572	word	readers))	2	t	(())
25576	804	25560	word	 and 	8	t	(())
25577	804	25560	formatted		9	t	(())
25578	804	25577	compound		0	t	(())
25579	804	25578	word	WRITE	0	t	(())
25580	804	25578	word	((	1	t	(())
25581	804	25578	word	writers))	2	t	(())
25582	804	25560	word	 should be selected. Using control ((Windows)) or command ((Mac)), select an additional label of 	10	t	(())
25583	804	25560	formatted		11	t	(())
25584	804	25583	compound		0	t	(())
25585	804	25584	word	READ	0	t	(())
25586	804	25584	word	((	1	t	(())
25587	804	25584	word	auditors))	2	t	(())
25588	804	25560	word	, and click 	12	t	(())
25589	804	25560	formatted		13	t	(())
25590	804	25589	word	Save Labels	0	t	(())
25591	804	25560	word	.	14	t	(())
25592	804	25560	formatted		15	t	(())
25593	804	25592	word	\r\n\r\n	0	t	(())
25594	804	25560	word	Next, click 	16	t	(())
25595	804	25560	formatted		17	t	(())
25596	804	25595	word	View all labels	0	t	(())
25597	804	25560	word	. You should see that the label now contains read permission for the auditors group.	18	t	(())
25598	804	25560	formatted		19	t	(())
25599	804	25598	word	\r\n\r\n	0	t	(())
25600	804	25560	word	\r	20	t	(())
25601	804	25560	compound		21	t	(())
25602	804	25601	word	\n	0	t	(())
25603	804	25601	formatted		1	t	(())
25604	804	25603	compound		0	t	(())
25605	804	25604	word	.ACL\r\n	0	t	(())
25606	804	25604	word	..WRITE.writers\r\n	1	t	(())
25607	804	25604	word	..READ\r\n	2	t	(())
25608	804	25604	word	...readers\r\n	3	t	(())
25609	804	25604	word	...auditors\r\n	4	t	(())
25610	804	25560	word	\r	22	t	(())
25611	804	25560	word	\n	23	t	(())
25612	804	25560	word	Additionally, there is 	24	t	(())
25613	804	25560	formatted		25	t	(())
25614	804	25613	word	PROV LABEL	0	t	(())
25615	804	25560	word	 label, documenting that the label was changed.	26	t	(())
25616	804	25560	formatted		27	t	(())
25617	804	25616	word	\r\n\r\n	0	t	(())
25618	804	25560	word	Next 	28	t	(())
25619	804	25560	formatted		29	t	(())
25620	804	25619	word	Demo 4d Copy Paste Revisited	0	t	(())
25621	804	25560	formatted		30	t	(())
25622	804	25621	word	\r\n\r\n	0	t	(())
25625	805	25623	compound		0	t	(())
25626	805	25625	word	So far we have described how to view and modify labels. In this section, we demonstrate label enforcement. To start, in your second window:	0	t	(())
25627	805	25625	formatted		1	t	(())
25628	805	25627	word	\r\n\r\n	0	t	(())
25629	805	25625	word	\r	2	t	(())
25630	805	25625	compound		3	t	(())
25631	805	25630	word	\n	0	t	(())
25632	805	25630	formatted		1	t	(())
25633	805	25632	compound		0	t	(())
25634	805	25633	formatted		0	t	(())
25635	805	25634	formatted		0	t	(())
25636	805	25635	compound		0	t	(())
25637	805	25636	word	Click 	0	t	(())
25638	805	25636	formatted		1	t	(())
25639	805	25638	word	Main menu	0	t	(())
25640	805	25636	word	\r	2	t	(())
25641	805	25636	word	\n	3	t	(())
25642	805	25633	formatted		1	t	(())
25643	805	25642	formatted		0	t	(())
25644	805	25643	compound		0	t	(())
25645	805	25644	word	Select 	0	t	(())
25646	805	25644	formatted		1	t	(())
25647	805	25646	word	Demo Restricted	0	t	(())
25648	805	25644	word	 from the drop down menu	2	t	(())
25649	805	25644	word	\r	3	t	(())
25650	805	25644	word	\n	4	t	(())
25651	805	25633	formatted		2	t	(())
25652	805	25651	formatted		0	t	(())
25653	805	25652	compound		0	t	(())
25654	805	25653	word	Click 	0	t	(())
25655	805	25653	formatted		1	t	(())
25656	805	25655	word	Load selected page	0	t	(())
25657	805	25653	word	\r	2	t	(())
25658	805	25653	word	\n	3	t	(())
25659	805	25633	formatted		3	t	(())
25660	805	25659	formatted		0	t	(())
25661	805	25660	compound		0	t	(())
25662	805	25661	word	Click 	0	t	(())
25663	805	25661	formatted		1	t	(())
25664	805	25663	word	View all labels	0	t	(())
25665	805	25661	word	\r	2	t	(())
25666	805	25661	word	\n	3	t	(())
25667	805	25625	word	\r	4	t	(())
25668	805	25625	word	\n	5	t	(())
25669	805	25625	word	You will be presented with a page with three lines. The first line is writable by the 	6	t	(())
25670	805	25625	formatted		7	t	(())
25671	805	25670	word	writers	0	t	(())
25672	805	25625	word	 group. The second line is only writable by the 	8	t	(())
25673	805	25625	formatted		9	t	(())
25674	805	25673	word	administrators	0	t	(())
25675	805	25625	word	 group, of which 	10	t	(())
25676	805	25625	formatted		11	t	(())
25677	805	25676	word	demo	0	t	(())
25678	805	25625	word	 is not a member. 	12	t	(())
25679	805	25625	formatted		13	t	(())
25680	805	25679	word	\r\n\r\n	0	t	(())
25681	805	25625	word	The third line is only viewable by the 	14	t	(())
25682	805	25625	formatted		15	t	(())
25683	805	25682	word	administrators	0	t	(())
25684	805	25625	word	 group, so the access control policy prevents it from being displayed, instead showing 	16	t	(())
25685	805	25625	formatted		17	t	(())
25686	805	25685	word	Access Denied	0	t	(())
25687	805	25625	word	.	18	t	(())
25688	805	25625	formatted		19	t	(())
25689	805	25688	word	\r\n\r\n	0	t	(())
25690	805	25625	word	Now we will attempt to edit the middle block, where we have read access, but no write access. In that window, click 	20	t	(())
25691	805	25625	formatted		21	t	(())
25692	805	25691	word	Modify Page	0	t	(())
25693	805	25625	word	, then click 	22	t	(())
25694	805	25625	formatted		23	t	(())
25695	805	25694	word	Edit	0	t	(())
25696	805	25625	word	 in the second red, Labeled block. Change the text and click 	24	t	(())
25697	805	25625	formatted		25	t	(())
25698	805	25697	word	Save WikiEdit	0	t	(())
25699	805	25625	word	. 	26	t	(())
25700	805	25625	formatted		27	t	(())
25701	805	25700	word	\r\n\r\n	0	t	(())
25702	805	25625	word	The access	28	t	(())
25703	805	25625	word	-	29	t	(())
25704	805	25625	word	control policy checks the permissions for the edit, and	30	t	(())
25705	805	25625	word	\r	31	t	(())
25706	805	25625	word	\n	32	t	(())
25707	805	25625	word	disallows it with a 	33	t	(())
25708	805	25625	formatted		34	t	(())
25709	805	25708	word	SecurityException	0	t	(())
25710	805	25625	word	. Click your browser's 	35	t	(())
25711	805	25625	formatted		36	t	(())
25712	805	25711	word	back	0	t	(())
25713	805	25625	word	\r	37	t	(())
25714	805	25625	word	\n	38	t	(())
25715	805	25625	word	button to get back to the Wiki.	39	t	(())
25716	805	25625	formatted		40	t	(())
25717	805	25716	word	\r\n\r\n	0	t	(())
25718	805	25625	word	Continue to 	41	t	(())
25719	805	25625	formatted		42	t	(())
25720	805	25719	word	Demo 6 Conclusion	0	t	(())
25758	807	25756	compound		0	t	(())
25759	807	25758	word	You should still have the prior page you copied in the copy buffer; we will now re	0	t	(())
25760	807	25758	word	-	1	t	(())
25761	807	25758	word	paste it into your current document. On the page that you created ((	2	t	(())
25762	807	25758	formatted		3	t	(())
25763	807	25762	word	My Labeled Page	0	t	(())
25764	807	25758	word	)), click 	4	t	(())
25765	807	25758	formatted		5	t	(())
25766	807	25765	word	Modify page	0	t	(())
25767	807	25758	word	, then click one of the 	6	t	(())
25768	807	25758	formatted		7	t	(())
25769	807	25768	word	Paste	0	t	(())
25770	807	25758	word	 buttons. As before, the copied block will be pasted below the selected block.	8	t	(())
25771	807	25758	formatted		9	t	(())
25772	807	25771	word	\r\n\r\n	0	t	(())
25773	807	25758	word	Next, click 	10	t	(())
25774	807	25758	formatted		11	t	(())
25775	807	25774	word	View all labels	0	t	(())
25776	807	25758	word	. In the block you pasted, there is both a 	12	t	(())
25777	807	25758	formatted		13	t	(())
25778	807	25777	word	PROV PASTE	0	t	(())
25779	807	25758	word	 label detailing the paste operation, as well as the provenance information detailing how the block was originally created.	14	t	(())
25780	807	25758	formatted		15	t	(())
25781	807	25780	word	\r\n\r\n	0	t	(())
25782	807	25758	word	In section 	16	t	(())
25783	807	25758	formatted		17	t	(())
25784	807	25783	word	Demo 4e Access Control in Action	0	t	(())
25785	807	25758	word	, we will examine to how the access control labels are used to enforce our access control policy.	18	t	(())
25786	807	25758	formatted		19	t	(())
25787	807	25786	word	\r\n\r\n	0	t	(())
25788	807	25758	word	\r	20	t	(())
25789	807	25758	word	\n	21	t	(())
25822	806	25821	compound		0	t	(())
25823	806	25822	word	You have now seen all of the features of the SEWiki system. This concludes the tutorial. 	0	t	(())
25824	806	25822	formatted		1	t	(())
25825	806	25824	word	\r\n\r\n	0	t	(())
25826	806	25822	word	If you wish, you can delete the sample pages you created. Click on 	2	t	(())
25827	806	25822	formatted		3	t	(())
25828	806	25827	word	Main menu	0	t	(())
25829	806	25822	word	, select the name of the page you created ((	4	t	(())
25830	806	25822	formatted		5	t	(())
25831	806	25830	word	My Test Page	0	t	(())
25832	806	25822	word	 or 	6	t	(())
25833	806	25822	formatted		7	t	(())
25834	806	25833	word	My Labeled Page	0	t	(())
25835	806	25822	word	)), click 	8	t	(())
25836	806	25822	formatted		9	t	(())
25837	806	25836	word	Load Selected Page	0	t	(())
25838	806	25822	word	, and finally, click 	10	t	(())
25839	806	25822	formatted		11	t	(())
25840	806	25839	word	Delete page	0	t	(())
25841	806	25822	word	.	12	t	(())
25842	806	25822	formatted		13	t	(())
25843	806	25842	word	\r\n\r\n	0	t	(())
25844	806	25822	formatted		14	t	(())
25846	806	25822	word	\r	15	t	(())
25847	806	25822	word	\n	16	t	(())
25848	806	25822	formatted		17	t	(())
25849	806	25848	word	Demo 1 Overview	0	t	(())
25850	806	25822	formatted		18	t	(())
25851	806	25850	word	\r\n\r\n	0	t	(())
25854	808	25852	compound		0	t	(())
25855	808	25854	word	This page contains the complete overview of this document.	0	t	(())
25856	808	25854	formatted		1	t	(())
25857	808	25856	word	\r\n\r\n	0	t	(())
25858	808	25854	word	\r	2	t	(())
25859	808	25854	compound		3	t	(())
25860	808	25859	word	\n	0	t	(())
25861	808	25859	formatted		1	t	(())
25862	808	25861	compound		0	t	(())
25863	808	25862	formatted		0	t	(())
25864	808	25863	formatted		0	t	(())
25865	808	25864	compound		0	t	(())
25866	808	25865	formatted		0	t	(())
25867	808	25866	word	Demo 1 Overview	0	t	(())
25868	808	25865	word	\r	1	t	(())
25869	808	25865	word	\n	2	t	(())
25870	808	25862	formatted		1	t	(())
25871	808	25870	formatted		0	t	(())
25872	808	25871	compound		0	t	(())
25873	808	25872	formatted		0	t	(())
25874	808	25873	word	Demo 2 Background	0	t	(())
25875	808	25872	word	\r	1	t	(())
25876	808	25872	word	\n	2	t	(())
25877	808	25862	formatted		2	t	(())
25878	808	25877	formatted		0	t	(())
25879	808	25878	compound		0	t	(())
25880	808	25879	formatted		0	t	(())
25881	808	25880	word	Demo 2a Links	0	t	(())
25882	808	25879	word	\r	1	t	(())
25883	808	25879	word	\n	2	t	(())
25884	808	25862	formatted		3	t	(())
25885	808	25884	formatted		0	t	(())
25886	808	25885	compound		0	t	(())
25887	808	25886	formatted		0	t	(())
25888	808	25887	word	Demo 2b SELinks	0	t	(())
25889	808	25886	word	\r	1	t	(())
25890	808	25886	word	\n	2	t	(())
25891	808	25862	formatted		4	t	(())
25892	808	25891	formatted		0	t	(())
25893	808	25892	compound		0	t	(())
25894	808	25893	formatted		0	t	(())
25895	808	25894	word	Demo 2c SEWiki	0	t	(())
25896	808	25893	word	\r	1	t	(())
25897	808	25893	word	\n	2	t	(())
25898	808	25862	formatted		5	t	(())
25899	808	25898	formatted		0	t	(())
25900	808	25899	compound		0	t	(())
25901	808	25900	formatted		0	t	(())
25902	808	25901	word	Demo 3 Wiki Features	0	t	(())
25903	808	25900	word	\r	1	t	(())
25904	808	25900	word	\n	2	t	(())
25905	808	25862	formatted		6	t	(())
25906	808	25905	formatted		0	t	(())
25907	808	25906	compound		0	t	(())
25908	808	25907	formatted		0	t	(())
25909	808	25908	word	Demo 3a TextEditing	0	t	(())
25910	808	25907	word	\r	1	t	(())
25911	808	25907	word	\n	2	t	(())
25912	808	25862	formatted		7	t	(())
25913	808	25912	formatted		0	t	(())
25914	808	25913	compound		0	t	(())
25915	808	25914	formatted		0	t	(())
25916	808	25915	word	Demo 3b Text Formatting	0	t	(())
25917	808	25914	word	\r	1	t	(())
25918	808	25914	word	\n	2	t	(())
25919	808	25862	formatted		8	t	(())
25920	808	25919	formatted		0	t	(())
25921	808	25920	compound		0	t	(())
25922	808	25921	formatted		0	t	(())
25923	808	25922	word	Demo 3c URLs	0	t	(())
25924	808	25921	word	\r	1	t	(())
25925	808	25921	word	\n	2	t	(())
25926	808	25862	formatted		9	t	(())
25927	808	25926	formatted		0	t	(())
25928	808	25927	compound		0	t	(())
25929	808	25928	formatted		0	t	(())
25930	808	25929	word	Demo 3d Other Features	0	t	(())
25931	808	25928	word	\r	1	t	(())
25932	808	25928	word	\n	2	t	(())
25933	808	25862	formatted		10	t	(())
25934	808	25933	formatted		0	t	(())
25935	808	25934	compound		0	t	(())
25936	808	25935	formatted		0	t	(())
25937	808	25936	word	Demo 3e Copy Paste	0	t	(())
25938	808	25935	word	\r	1	t	(())
25939	808	25935	word	\n	2	t	(())
25940	808	25862	formatted		11	t	(())
25941	808	25940	formatted		0	t	(())
25942	808	25941	compound		0	t	(())
25943	808	25942	formatted		0	t	(())
25944	808	25943	word	Demo 4 Labels	0	t	(())
25945	808	25942	word	\r	1	t	(())
25946	808	25942	word	\n	2	t	(())
25947	808	25862	formatted		12	t	(())
25948	808	25947	formatted		0	t	(())
25949	808	25948	compound		0	t	(())
25950	808	25949	formatted		0	t	(())
25951	808	25950	word	Demo 4a Creating a Page Revisited	0	t	(())
25952	808	25949	word	\r	1	t	(())
25953	808	25949	word	\n	2	t	(())
25954	808	25862	formatted		13	t	(())
25955	808	25954	formatted		0	t	(())
25956	808	25955	compound		0	t	(())
25957	808	25956	formatted		0	t	(())
25958	808	25957	word	Demo 4b Modifying Content Revisited	0	t	(())
25959	808	25956	word	\r	1	t	(())
25960	808	25956	word	\n	2	t	(())
25961	808	25862	formatted		14	t	(())
25962	808	25961	formatted		0	t	(())
25963	808	25962	compound		0	t	(())
25964	808	25963	formatted		0	t	(())
25965	808	25964	word	Demo 4c Modifying Access Control	0	t	(())
25966	808	25963	word	\r	1	t	(())
25967	808	25963	word	\n	2	t	(())
25968	808	25862	formatted		15	t	(())
25969	808	25968	formatted		0	t	(())
25970	808	25969	compound		0	t	(())
25971	808	25970	formatted		0	t	(())
25972	808	25971	word	Demo 4d Copy Paste Revisited	0	t	(())
25973	808	25970	word	\r	1	t	(())
25974	808	25970	word	\n	2	t	(())
25975	808	25862	formatted		16	t	(())
25976	808	25975	formatted		0	t	(())
25977	808	25976	compound		0	t	(())
25978	808	25977	formatted		0	t	(())
25979	808	25978	word	Demo 4e Access Control in Action	0	t	(())
25980	808	25977	word	\r	1	t	(())
25981	808	25977	word	\n	2	t	(())
25982	808	25862	formatted		17	t	(())
25983	808	25982	formatted		0	t	(())
25984	808	25983	compound		0	t	(())
25985	808	25984	formatted		0	t	(())
25986	808	25985	word	Demo 5 Conclusion	0	t	(())
25987	808	25984	word	\r	1	t	(())
25988	808	25984	word	\n	2	t	(())
25989	808	25854	formatted		4	t	(())
25990	808	25989	word	\r\n\r\n	0	t	(())
25991	808	25854	word	Let's begin with 	5	t	(())
25992	808	25854	formatted		6	t	(())
25993	808	25992	word	Demo 2 Background	0	t	(())
25994	808	25854	word	.	7	t	(())
26141	812	26141	word	This is a third attempt at the first page successfully created in SELinks	0	\N	(())
26263	813	26263	labeled		0	\N	(())
26264	813	26263	compound		0	\N	(())
26265	813	26264	word	This is a fourth attempt at the first page successfully created in SELinks.	0	\N	(())
26266	813	26264	formatted		1	\N	(())
26267	813	26266	word	\r\n\r\n	0	\N	(())
26268	813	26264	word	And it worked	2	\N	(())
26269	813	26264	word	!	3	\N	(())
26287	814	26287	labeled		0	\N	(())
26288	814	26287	word	A new hope.	0	\N	(())
\.


--
-- Data for Name: pages; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY pages (pageid, creator, title) FROM stdin;
776	30	*Start Here*
780	30	Demo 2 Background
781	30	Demo 2a Links
784	30	Demo 3 Wiki Features
786	30	Demo 3a TextEditing
787	30	Demo 3b Text Formatting
788	30	Demo 3c URLs
790	30	Demo 3d Other Features
792	30	Demo 3e Copy Paste
765	30	Demo Restricted
801	30	Demo 4 Labels
802	30	Demo 4a Creating a Page Revisited
804	30	Demo 4c Modifying Access Control
805	30	Demo 4e Access Control in Action
807	30	Demo 4d Copy Paste Revisited
808	30	Demo 1 Overview
782	30	Demo 2b SELinks
783	30	Demo 2c SEWiki
803	30	Demo 4b Modifying Content Revisited
806	30	Demo 5 Conclusion
812	30	SELinks!
813	30	SELinks II
814	30	A new page
\.


--
-- Data for Name: stuff; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY stuff (id, data_l, data) FROM stdin;
0	Acl(Brian,Acl(Nik,Nil))	Grad student stuff
1	Acl(Mike,Nil)	Professor stuff
\.


--
-- Data for Name: tag_user_xref; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY tag_user_xref (tagid, userid) FROM stdin;
1	30
1	32
1	31
1	2
1	1
2	1
2	2
2	30
2	31
2	32
2	33
2	34
3	34
3	32
3	31
3	30
3	2
3	1
6	30
\.


--
-- Data for Name: tags; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY tags (tagid, "owner", name) FROM stdin;
1	1	administrators
4	1	auditors
6	30	Brian
3	1	authors
2	1	guests
\.


--
-- Data for Name: test_label; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY test_label (a, b) FROM stdin;
Foo	Bar(Ball)
High	High(Lo)
High	High(A)
Bar	Cons(Foo,Empty)
\.


--
-- Data for Name: users; Type: TABLE DATA; Schema: public; Owner: selinks
--

COPY users (name, "password", credential, userid) FROM stdin;
admin	adminpw	0	1
reader	readerpw	50	33
Brian	Brianpw	47	30
Mike	Mikepw	49	32
Cody	Codypw	48	31
Nik	Nikpw	0	2
demo	demopw	51	34
\.


--
-- Name: pages_pkey; Type: CONSTRAINT; Schema: public; Owner: selinks; Tablespace: 
--

ALTER TABLE ONLY pages
    ADD CONSTRAINT pages_pkey PRIMARY KEY (pageid);


--
-- Name: pk_block_format; Type: CONSTRAINT; Schema: public; Owner: selinks; Tablespace: 
--

ALTER TABLE ONLY block_format
    ADD CONSTRAINT pk_block_format PRIMARY KEY (pageid, blockid, userid);


--
-- Name: pk_page_blocks; Type: CONSTRAINT; Schema: public; Owner: selinks; Tablespace: 
--

ALTER TABLE ONLY page_blocks
    ADD CONSTRAINT pk_page_blocks PRIMARY KEY (blockid, pageid);


--
-- Name: pk_tag_user; Type: CONSTRAINT; Schema: public; Owner: selinks; Tablespace: 
--

ALTER TABLE ONLY tag_user_xref
    ADD CONSTRAINT pk_tag_user PRIMARY KEY (tagid, userid);


--
-- Name: tags_pkey; Type: CONSTRAINT; Schema: public; Owner: selinks; Tablespace: 
--

ALTER TABLE ONLY tags
    ADD CONSTRAINT tags_pkey PRIMARY KEY (tagid);


--
-- Name: users_pkey; Type: CONSTRAINT; Schema: public; Owner: selinks; Tablespace: 
--

ALTER TABLE ONLY users
    ADD CONSTRAINT users_pkey PRIMARY KEY (userid);


--
-- Name: bf_foreign_key; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY block_format
    ADD CONSTRAINT bf_foreign_key FOREIGN KEY (blockid, pageid) REFERENCES page_blocks(blockid, pageid) ON DELETE CASCADE;


--
-- Name: bl_foreign_key; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY block_label
    ADD CONSTRAINT bl_foreign_key FOREIGN KEY (blockid, pageid) REFERENCES page_blocks(blockid, pageid) ON DELETE CASCADE;


--
-- Name: block_format_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY block_format
    ADD CONSTRAINT block_format_userid_fkey FOREIGN KEY (userid) REFERENCES users(userid) ON DELETE CASCADE;


--
-- Name: page_blocks_pageid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY page_blocks
    ADD CONSTRAINT page_blocks_pageid_fkey FOREIGN KEY (pageid) REFERENCES pages(pageid) ON DELETE CASCADE;


--
-- Name: pages_creator_fkey; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY pages
    ADD CONSTRAINT pages_creator_fkey FOREIGN KEY (creator) REFERENCES users(userid);


--
-- Name: pk_parent; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY page_blocks
    ADD CONSTRAINT pk_parent FOREIGN KEY (parentblockid, pageid) REFERENCES page_blocks(blockid, pageid) ON DELETE CASCADE;


--
-- Name: tag_user_xref_tagid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY tag_user_xref
    ADD CONSTRAINT tag_user_xref_tagid_fkey FOREIGN KEY (tagid) REFERENCES tags(tagid);


--
-- Name: tag_user_xref_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY tag_user_xref
    ADD CONSTRAINT tag_user_xref_userid_fkey FOREIGN KEY (userid) REFERENCES users(userid);


--
-- Name: tags_owner_fkey; Type: FK CONSTRAINT; Schema: public; Owner: selinks
--

ALTER TABLE ONLY tags
    ADD CONSTRAINT tags_owner_fkey FOREIGN KEY ("owner") REFERENCES users(userid);


--
-- Name: public; Type: ACL; Schema: -; Owner: selinks
--

GRANT ALL ON SCHEMA public TO selinks;
GRANT ALL ON SCHEMA public TO PUBLIC;

--
-- Name: block_format; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON TABLE block_format TO selinks;


--
-- Name: block_label; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON TABLE block_label TO selinks;


--
-- Name: blockid_sequence; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON SEQUENCE blockid_sequence TO selinks;


--
-- Name: page_blocks; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON TABLE page_blocks TO selinks;


--
-- Name: pageid_sequence; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON SEQUENCE pageid_sequence TO selinks;


--
-- Name: pages; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON TABLE pages TO selinks;


--
-- Name: tag_user_xref; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON TABLE tag_user_xref TO selinks;


--
-- Name: tags; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON TABLE tags TO selinks;


--
-- Name: tags_tagid_seq; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON SEQUENCE tags_tagid_seq TO selinks;


--
-- Name: userid_sequence; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON SEQUENCE userid_sequence TO selinks;


--
-- Name: users; Type: ACL; Schema: public; Owner: selinks
--

GRANT ALL ON TABLE users TO selinks;


--
-- PostgreSQL database dump complete
--

